# Cratermaker
## Simulate the evolution of a landscape dominated by impact bombardment.

Cratermaker is a landscape evolution model that simulates the evolution of a planetary surface subjected to impact bombardment. It began as a modernized re-write of the older [Cratered Terrain Evolution Model (CTEM)](https://github.com/MintonGroup/CTEM/), but in most ways it is far more capable[^1]. While its core function is as a planetary cratering landscape evolution model, its various components can be used independently for crater to impactor scaling, modeling production functions, extracting lunar elevation models, and much more.

> **_Note_**: Cratermaker is still in alpha stage of development. Not all components and models have been tested thoroughly, so please use caution and always double check the results when using the code for scientific purposes (which you should be doing anyway). 

[^1]: Currently the only major capabilities of CTEM that Cratermaker lacks are material tracking and quasi Monte Carlo mode. See our [issues](https://github.com/MintonGroup/cratermaker/issues) page of ongoing development tasks.

### Getting Started with Cratermaker

Cratermaker is designed to be both user-friendly and highly configurable, ensuring that users can start simulations quickly with reasonable defaults or tailor their simulations to specific needs. It is built to be highly modular, and so many of the core components of Cratermaker can be run independently, outside of its core landscape evolution simulation.

Cratermaker is a Python package that is designed to work with Python 3.10 or later on MacOS, Linux, and Windows. It contains some Rust components for performance. You may need to install Rust before installing Cratermaker. Installation instructions for your operating system can be found in [the Rust documentation](https://www.rust-lang.org/tools/install).

### Install dependencies

Some components of Cratermaker use OpenBLAS for linear algebra operations. On some systems, you may need to install OpenBLAS separately before installing Cratermaker. Installation instructions for your operating system can be found in [the OpenBLAS documentation](http://www.openmathlib.org/OpenBLAS/docs/install).  You may also need to install OpenSSL development libraries for your system.

Cratermaker uses a number of packages which must be installed on the system before it can be built. If any are missing, they could cause a failure to build. Try one of the following, depending on what OS you are using:

##### Debian Linux (e.g. Ubuntu)

```sh
sudo apt-get update 
sudo apt-get install pkg-config libssl-dev libopenblas-dev
```

##### Redhat Linux (e.g. Fedora) with yum

```sh
yum install epel-release
yum install pkgconfig openssl-devel openblas-devel
```

###### Redhat Linux (e.g. Fedora) with dnf

```sh    
dnf install pkgconf-pkg-config openssl-devel flexiblas-devel 
```

##### MacOS with Homebrew

```sh
brew install openssl@3 openblas
```

##### Windows with vcpkg

```sh
vcpkg install openblas intel-mkl --triplet x64-windows
```

### Normal Installation

You can install Cratermaker using pip into the Python environment of your choice, provided it is at least Python 3.10 or above.

```sh
pip install cratermaker
```

> **_Note_**: Cratermaker is undergoing active development, as it is still in alpha stage. You may need to update your installation frequently to get the latest features and bug fixes. You can do this using the following command:
>  `pip install --upgrade cratermaker`


### Installing Cratermaker from Source

If you plan to contribute to Cratermaker, or want to try out the latest features that have not yet been released, you can install Cratermaker from source. You can find the latest source code from our `GitHub repository <https://github.com/MintonGroup/cratermaker>`__.  

Some components of Cratermaker are built using Rust, and so you will need to have Rust installed on your system to build Cratermaker from source. Installation instructions for your operating system can be found in `the Rust documentation <https://rust-lang.org/learn/get-started/>`__.

The first time you install Cratermaker from source, you will need to generate the version file. Due to limitations of the Maturin build system, this must be done manually. You do this by running the following command in the root directory of the Cratermaker source code:

```sh
python buildscripts/set_version.py    
```

For development, it's best to build and install the package in "editable" mode. To build and install an editable version you can install Cratermaker from source using the following command:

```sh
pip install -e .      
```

##### Building documentation pages

The documentation pages are built using Sphinx. If you wish to build local versions of the documentation for testing, you will need to install additional dependencies that are not installed by default. We maintain a two requirements files for this purpose, one for pip, and the other for conda, which is used by the Read the Docs build system. You can install the documentation dependencies using the following command:

```sh
pip install -r environments/requirements-docdev.txt
```

or, you can generate a conda environment using the conda requirements file:

```sh
conda env create -f environments/cratermaker-docs.yml
```

Once you have installed the documentation dependencies, be sure that you also have installed Cratermaker as an editable install into the same environment. Then you can build the documentation using the following command:

```sh
cd docs
make clean
make rtdhtml
```

The documentation pages will be built in the `docs/_build/html` directory, which you can then open in your web browser to view.

#### Automatically rebuild Rust components

The build backend for the Rust components is Maturin. Maturin provides an import hook that can allow the Rust libraries to be automatically recompiled if they are changed, which is useful when Cratermaker installed in editable configuration. To use this, first install the package:

```sh
pip install maturin_import_hook
```

In the same virtual environment that you installed Cratermaker in, activate the import hook:

```sh
python -m maturin_import_hook site install
```

For more information, see the the [Import Hook](https://www.maturin.rs/import_hook.html) section of the Maturin documentation.

### Common problems 

Here are a few things you can try if you have trouble installing the Cratermaker project from source.


##### Make sure Rust is up-to-date

Be sure your rust install is up-to-date 

```sh
rustup update --nightly
```


If you see errors related to linalg functions, you may have an old and incompatable linalg crate installed. The most expedient way I've found to deal with this is to remove the Cargo.lock file. You can do this in a clean way with the cargo-unlock crate:

```sh
cargo install cargo-unlock
cargo unlock
```

##### Installing polars on legacy hardware

If you ever see an error like this::

```
illegal hardware instruction (core dumped)
```

Or a message about polars and incompatible hardware, you may have to install the runtime-compatability version of polars.

```sh
pip install "polars[rtcompat]"
```

### Documentation    

For more detail, see the [documentation](https://cratermaker.readthedocs.io/en/latest/) page.

Readme for mpas_mesh_converter.cpp and mpas_cell_culler.cpp

Author: Doug Jacobsen <douglasj@lanl.gov>

Purpose:
    mpas_mesh_converter.cpp is a piece of software designed create an MPAS mesh.
    As input, this software takes the locations of MPAS cell centers, and cell
    vertices, along with the connectivity array cellsOnVertex. If provided, it
    will also migrate data from the meshDensity field, if it's not present it
    will write 1.0 for every cell.

    mpas_cell_culler.cpp is a piece of software designed remove
    cells/edge/vertices from an MPAS mesh.  As input, this software takes a
    valid MPAS mesh with one additional field "cullCell". This new field should
    be nCells integers. A 1 means the cell should be kept, and a 0 means the
    cell should be removed.

    mpas_mask_creator.cpp is a piece of software designed to create cell masks
    from region definitions. Region definitions are defined in geojson files,
    and can be created using the tools contained within the repository located
    at:
    https://github.com/MPAS-Dev/geometric_features
    Masks have a value of 0 or 1, and are integers.

Requirements:
    mpas_mesh_converter.cpp requires the c++ netcdf libraries to be able to read/write NetCDF files.
    It also requires the tr1 headers for c++, specifically unordered_set.
    It has been tested using g++ version 4.8.1

    mpas_cell_culler.cpp requires the c++ netcdf libraries to be able to read/write NetCDF files.
    It has been tested using g++ version 4.8.1

    mpas_mask_creator.cpp requires the c++ netcdf libraries to be able to read/write NetCDF files.
    It has been tested using g++ version 4.8.1

Usage of mpas_mesh_converter.cpp:
    ./MpasMeshConverter.x [input_name] [output_name]

    input_name:
        The input_name should be the name of a NetCDF file containing the following information.
            Dimensions:
                nCells - The number of cells described in the file.
                nVertices - The number of vertices described in the file.
                vertexDegree - The maximum number of cells that surround each vertex.
            Variables:
                xCell -- The x location of every cell center.
                yCell -- The y location of every cell center.
                zCell -- The z location of every cell center.
                xVertex -- The x location of every vertex (cell corner).
                yVertex -- The y location of every vertex (cell corner).
                zVertex -- The z location of every vertex (cell corner).
                cellsOnVertex -- A list of cell indices that border each vertex (Dimensioned vertexDegree * nVertices).
                                 This list can contain -1 values if the dual cell is not complete (e.g. a line rather than a triangle).
                meshDensity -- (Optional) The value of the generating density function at each cell center.
                               If this variable is ommitted, it is filled with 1.0 on output.
            Global Attributes:
                on_a_sphere -- Should be "YES" if the cells/vertices are defined on a sphere and "NO" if they are defined in a plane.
                history -- (Optional) Should be defined to a string describing how the input file was generated.
                mesh_id -- (Optional) Should be a 40 character string (Alpha-Numeric) that can be used to identify the mesh.
                           If ommitted, a random string will be placed in the output file.
    output_name:
        The output_name should be the name of the NetCDF file that will be generated. It will be a valid MPAS mesh.
        No initial conditions are placed in this file. If input_name is specified, output_name defaults to mesh.nc.


Usage of mpas_cell_culler.cpp:
    ./MpasCellCuller.x [input_name] [output_name] [[-m/-i] mask_file] [-c]

    input_name:
        The input name should be the name of a NetCDF file that is a fully valid MPAS file.
        It is required to have all of the fields an output file from MpasMeshConverter.x contains.
        There is one additional field:
        cullCell -- (Optional) Should be dimensioned nCells. Should contain a 1 for all cells that should be removed
                    and a 0 for all cells that should be kept.

    output_name:
        The output_name should be the name of the NetCDF file that will be generated. It will be the same as the input file,
        with cells, edges, and vertices removed where appropriate. Also, the cullCell field will be removed.
        If input_name is specified, outputname defaults to culled_mesh.nc.

    -m/-i:
        These flags allow the addition of a masks file to be used to define
        cells that should be culled.
        If the -m flag is used, the masks file is used to cull the mesh.
        Meaning, where any mask in the masks file is 1, the mesh will be
        culled.
        If the -i flag is used, the inverse of the masks file is used to cull
        the mesh. Meaning where all masks in the masks file are 0, the mesh
        will be culled.

    mask_file:
        The mask_file argument should be the name of a NetCDF file containing
        the regionCellMasks field, which defines masks for culling cells.

    -c:
        Output the mapping from old to new mesh (cellMap) in cellMapForward.txt,
        and output the reverse mapping from new to old mesh in cellMapBackward.txt.

Usage of mpas_mask_creator.cpp:
    ./MpasMaskCreator.x [input_mesh] [output_masks] [feature_group1] [feature_group2] ... [feature_groupN]

    input_name:
        The input name should be the path to a NetCDF file that is a fully valid MPAS file.

    output_masks:
        The output masks should be the path to a NetCDF file that will be
        generated. It will contain all of the mask information after applying
        the region specifications to the input name mesh file.

    feature_groupN:
        After the output masks argument, the mask creator can take an arbitrary
        number of feature files. The mask creator assumes each file is a group
        of features (regions, transects, point data, etc.). Each file must be
        formatted as geojson, and the name of each group should be contained
        within the file.

        The mask creator assumes the latitude and longitude contained within
        each geojson file are given in degrees, and that the latitude ranges
        from -90 to 90, while the longitude ranges from -180 to 180.

Notes for mpas_mesh_converter.cpp:
    - The output mesh should have an attribute "mesh_spec" which defined which
        version of the MPAS Mesh Specification this mesh conforms to.
    - Cells that are not complete (e.g. are not surrounded by vertices) will be
        given a negative area.
    - Negative area cells can be removed at a later state to remove non-complete
        cells.


Notes for mpas_cell_culler.cpp:
    - Cells that contain negative area will be removed in addition to all cells that have
        a cullCell value of 1.

## `JIGSAW: An unstructured mesh generator`

<p align="middle">
  <img src = "../master/external/jigsaw/img/bunny-TRIA3-1.png" width="20%" hspace="0.25%">
  <img src = "../master/external/jigsaw/img/bunny-TRIA3-2.png" width="20%" hspace="0.25%">
  <img src = "../master/external/jigsaw/img/bunny-TRIA3-3.png" width="20%" hspace="0.25%">
  <img src = "../master/external/jigsaw/img/bunny-TRIA4-3.png" width="20%" hspace="0.25%">
</p>

`JIGSAW` is an unstructured mesh generator and tessellation library; designed to generate high-quality triangulations and polyhedral decompositions of general planar, surface and volumetric domains. `JIGSAW` includes refinement-based algorithms for the construction of new meshes, optimisation-driven techniques for the improvement of existing grids, as well as routines to assemble (restricted) Delaunay tessellations, Voronoi complexes and Power diagrams.

This package provides a <a href="http://www.python.org">`Python`</a> based scripting interface to the underlying `JIGSAW` mesh generator, including a range of additional facilities for file I/O, mesh visualisation and post-processing operations.

`JIGSAW` has been compiled and tested on various `64-bit` `Linux` , `Windows` and `Mac` based platforms. 

### `Quickstart`

    Ensure you have a c++ compiler and the cmake utility installed.
    Clone/download + unpack this repository.
    python3 setup.py build_external
    python3 setup.py install
    python3 example.py --IDnumber=0
    
Note: installation of `JIGSAW` requires a `c++` compiler and the `cmake` utility. `JIGSAW` may also be installed as a `conda` package. See <a href="https://github.com/dengwirda/jigsaw">here</a> for details.
    
### `Function Listing`

See `jigsawpy` for a description of the various functions available.

    setup.py    - compile and install JIGSAW's c++ backend using cmake.
    example.py  - a list of demo programs. 
    
    jigsaw.py   - cmd-line interface to JIGSAW's backend
    libsaw.py   - api-lib. interface to JIGSAW's backend
    
    loadmsh.py  - load *.msh files.
    savemsh.py  - save *.msh files.
    loadjig.py  - load *.jig files.
    savejig.py  - save *.jig files.

    project.py  - apply cartographic projection operators to mesh obj.

    bisect.py   - refine a mesh obj. via bisection.
    extrude.py  - create a mesh obj. via extrusion.

### `Example Problems`

The following set of example problems are available in `example.py`:

    example: 0; # simple 2-dim. examples to get started
    example: 1; # simple 3-dim. examples to get started
    example: 2; # frontal-delaunay methods in the plane
    example: 3; # frontal-delaunay methods for surfaces
    example: 4; # frontal-delaunay methods for volumes
    example: 5; # user-defined mesh-spacing constraints
    example: 6; # dealing with sharp-features in piecewise smooth domains
    example: 7; # dealing with sharp-features in piecewise smooth domains
    example: 8; # (re)mesh marching-cubes style outputs
    example: 9; # creating prismatic volumes via extrusion

Run `python3 example.py --IDnumber=N` to call the `N-th` example. `*.vtk` output is saved to `../cache` and can be visualised with, for example, <a href=https://www.paraview.org/>Paraview</a>.

### `License`

This program may be freely redistributed under the condition that the copyright notices (including this entire header) are not removed, and no compensation is received through use of the software.  Private, research, and institutional use is free.  You may distribute modified versions of this code `UNDER THE CONDITION THAT THIS CODE AND ANY MODIFICATIONS MADE TO IT IN THE SAME FILE REMAIN UNDER COPYRIGHT OF THE ORIGINAL AUTHOR, BOTH SOURCE AND OBJECT CODE ARE MADE FREELY AVAILABLE WITHOUT CHARGE, AND CLEAR NOTICE IS GIVEN OF THE MODIFICATIONS`. Distribution of this code as part of a commercial system is permissible `ONLY BY DIRECT ARRANGEMENT WITH THE AUTHOR`. (If you are not directly supplying this code to a customer, and you are instead telling them how they can obtain it for free, then you are not required to make any arrangement with me.) 

`DISCLAIMER`:  Neither I nor: Columbia University, the Massachusetts Institute of Technology, the University of Sydney, nor the National Aeronautics and Space Administration warrant this code in any way whatsoever.  This code is provided "as-is" to be used at your own risk.

### `References`

There are a number of publications that describe the algorithms used in `JIGSAW` in detail. If you make use of `JIGSAW` in your work, please consider including a reference to the following:

`[1]` - Darren Engwirda: Generalised primal-dual grids for unstructured co-volume schemes, J. Comp. Phys., 375, pp. 155-176, https://doi.org/10.1016/j.jcp.2018.07.025, 2018.

`[2]` - Darren Engwirda, Conforming Restricted Delaunay Mesh Generation for Piecewise Smooth Complexes, Procedia Engineering, 163, pp. 84-96, https://doi.org/10.1016/j.proeng.2016.11.024, 2016.

`[3]` - Darren Engwirda, Voronoi-based Point-placement for Three-dimensional Delaunay-refinement, Procedia Engineering, 124, pp. 330-342, http://dx.doi.org/10.1016/j.proeng.2015.10.143, 2015.

`[4]` - Darren Engwirda, David Ivers, Off-centre Steiner points for Delaunay-refinement on curved surfaces, Computer-Aided Design, 72, pp. 157-171, http://dx.doi.org/10.1016/j.cad.2015.10.007, 2016.

`[5]` - Darren Engwirda, Locally-optimal Delaunay-refinement and optimisation-based mesh generation, Ph.D. Thesis, School of Mathematics and Statistics, The University of Sydney, http://hdl.handle.net/2123/13148, 2014.

## `JIGSAW: An unstructured mesh generator`

<p align="middle">
  <img src = "../master/img/bunny-TRIA3-1.png" width="20%" hspace="0.25%">
  <img src = "../master/img/bunny-TRIA3-2.png" width="20%" hspace="0.25%">
  <img src = "../master/img/bunny-TRIA3-3.png" width="20%" hspace="0.25%">
  <img src = "../master/img/bunny-TRIA4-3.png" width="20%" hspace="0.25%">
</p>

`JIGSAW` is an unstructured mesh generator and tessellation library; designed to generate high-quality triangulations and polyhedral decompositions of general planar, surface and volumetric domains. `JIGSAW` includes refinement-based algorithms for the construction of new meshes, optimisation-driven techniques for the improvement of existing grids, as well as routines to assemble (restricted) Delaunay tessellations, Voronoi complexes and Power diagrams. 

This package provides the underlying `c++` source for `JIGSAW`; defining a basic command-line interface and a `c`-format `API`. Higher-level scripting interfaces, supporting a range of additional facilities for file I/O, mesh visualisation and post-processing operations are also available, including for <a href="http://www.mathworks.com">`MATLAB`</a> / <a href="http://www.gnu.org/software/octave">`OCTAVE`</a> <a href="https://github.com/dengwirda/jigsaw-matlab">here</a> and for <a href="https://www.python.org/">`PYTHON`</a> <a href="https://github.com/dengwirda/jigsaw-python">here</a>.

`JIGSAW` has been compiled and tested on various `64-bit` `Linux`, `Windows` and `MacOS` based platforms. 

### `Code Structure`

`JIGSAW` is written as a `header-only` library in `c++`. Both a basic command-line interface and a `c`-format `API` are defined:

      JIGSAW::
      ├── src -- JIGSAW src code
      ├── inc -- JIGSAW header files (for libjigsaw)
      ├── bin -- JIGSAW's exe binaries live here
      ├── lib -- JIGSAW's lib binaries live here
      ├── geo -- geometry definitions and input data
      ├── out -- default folder for JIGSAW output
      └── uni -- unit tests and libjigsaw example programs

### `Getting Started`

The first step is to compile and configure the code! `JIGSAW` can either be built directly from src, or installed using the <a href="https://anaconda.org/conda-forge/jigsaw">`conda`</a> package manager.

### `Building from src`

The full `JIGSAW` src can be found in <a href="../master/src/">`../jigsaw/src/`</a>. It has been built using various `c++17` conforming versions of the `g++`, `clang++` and `msvc` compilers.

`JIGSAW` is a `header-only` package - the single main `jigsaw.cpp` file simply `#include`'s the rest of the library directly. `JIGSAW` does not currently dependent on any external packages or libraries.

`JIGSAW` consists of several pieces: `(a)` a set of command-line utilities that read and write mesh data from/to file, and `(b)` a shared library, accessible via a `c`-format `API`.

### `Using cmake`

`JIGSAW` can be built using the <a href="https://cmake.org/">`cmake`</a> utility. To build, follow the steps below:

    * Clone or download this repository.
    * Navigate to the root `../jigsaw/` directory.
    * Make a new temporary directory BUILD.
    * cd build
    * cmake .. -DCMAKE_BUILD_TYPE=BUILD_MODE
    * cmake --build . --config BUILD_MODE --target install
    * Delete the temporary BUILD directory.

This process will build a series of executables and shared libraries: `jigsaw` itself - the main command-line meshing utility, `tripod` - `JIGSAW`'s tessellation infrastructure, `marche` - a fast-marching solver designed to optimise mesh-spacing configurations, as well as `libjigsaw` - `JIGSAW`'s shared `API`. `BUILD_MODE` can be used to select different compiler configurations and should generally either be `Release` or `Debug`. 

See `example.jig` for documentation on calling the command-line executables, and the headers in <a href="../master/inc/">`../jigsaw/inc/`</a> for details on the `API`.

### `Using conda`

`JIGSAW` is also available as a `conda` environment. To install and use, follow the steps below:

    * Ensure you have conda installed. If not, consider miniconda as a lightweight option.
    * Add conda-forge as a channel: conda config --add channels conda-forge
    * Create a jigsaw environment: conda create -n jigsaw jigsaw

Each time you want to use `JIGSAW` simply activate the environment using: `conda activate jigsaw`

Once activated, the various `JIGSAW` command-line utilities will be available in your run path, `JIGSAW`'s shared library (`libjigsaw`) will be available in your library path and its include files in your include path.

### `CMD-line Examples`

After compiling the code, try running the following command-line example to get started:
````
On WIN platforms:

\bin\jigsaw.exe example.jig

On LNX platforms:

/bin/jigsaw     example.jig
````
In this example, a high-quality tetrahedral mesh is generated for the 'stanford-bunny' geometry and the result written to file. The input geometry is specified as a triangulated surface, and is read from `../jigsaw/geo/bunny.msh`. The volume and surface mesh outputs are written to `../jigsaw/out/bunny.msh`. See the `example.jig` text-file for a description of `JIGSAW`'s configuration options. 

A repository of additional surface models generated using `JIGSAW` can be found <a href="https://github.com/dengwirda/jigsaw-models">here</a>. A description of the `*.jig` and `*.msh` input file formats can be found in the <a href="https://github.com/dengwirda/jigsaw/wiki">wiki</a>.

### `libJIGSAW Scripts`

A set of unit-tests and `libjigsaw` example programs are contained in <a href="../master/uni/">`../jigsaw/uni/`</a>. The `JIGSAW-API` is documented via the header files in <a href="../master/inc/">`../jigsaw/inc/`</a>. 

The unit-tests can be built using the <a href="https://cmake.org/">`cmake`</a> utility. To build, follow the steps below:

    * Navigate to the `../jigsaw/uni/` directory.
    * Make a new temporary directory BUILD.
    * cd build
    * cmake .. -DCMAKE_BUILD_TYPE=BUILD_MODE
    * cmake --build . --config BUILD_MODE --target install
    * Delete the temporary BUILD directory.

This process will build the unit-tests as a series of executables in <a href="../master/uni/">`../jigsaw/uni/`</a>. `BUILD_MODE` is a compiler configuration flag: either `Release` or `Debug`.

### `License`

This program may be freely redistributed under the condition that the copyright notices (including this entire header) are not removed, and no compensation is received through use of the software.  Private, research, and institutional use is free.  You may distribute modified versions of this code `UNDER THE CONDITION THAT THIS CODE AND ANY MODIFICATIONS MADE TO IT IN THE SAME FILE REMAIN UNDER COPYRIGHT OF THE ORIGINAL AUTHOR, BOTH SOURCE AND OBJECT CODE ARE MADE FREELY AVAILABLE WITHOUT CHARGE, AND CLEAR NOTICE IS GIVEN OF THE MODIFICATIONS`. Distribution of this code as part of a commercial system is permissible `ONLY BY DIRECT ARRANGEMENT WITH THE AUTHOR`. (If you are not directly supplying this code to a customer, and you are instead telling them how they can obtain it for free, then you are not required to make any arrangement with me.) 

`DISCLAIMER`:  Neither I nor: Columbia University, the Massachusetts Institute of Technology, the University of Sydney, nor the National Aeronautics and Space Administration warrant this code in any way whatsoever.  This code is provided "as-is" to be used at your own risk.

### `References`

There are a number of publications that describe the algorithms used in `JIGSAW` in detail. If you make use of `JIGSAW` in your work, please consider including a reference to the following:

`[1]` - Darren Engwirda: Generalised primal-dual grids for unstructured co-volume schemes, J. Comp. Phys., 375, pp. 155-176, https://doi.org/10.1016/j.jcp.2018.07.025, 2018.

`[2]` - Darren Engwirda, Conforming Restricted Delaunay Mesh Generation for Piecewise Smooth Complexes, Procedia Engineering, 163, pp. 84-96, https://doi.org/10.1016/j.proeng.2016.11.024, 2016.

`[3]` - Darren Engwirda, Voronoi-based Point-placement for Three-dimensional Delaunay-refinement, Procedia Engineering, 124, pp. 330-342, http://dx.doi.org/10.1016/j.proeng.2015.10.143, 2015.

`[4]` - Darren Engwirda, David Ivers, Off-centre Steiner points for Delaunay-refinement on curved surfaces, Computer-Aided Design, 72, pp. 157-171, http://dx.doi.org/10.1016/j.cad.2015.10.007, 2016.

`[5]` - Darren Engwirda, Locally-optimal Delaunay-refinement and optimisation-based mesh generation, Ph.D. Thesis, School of Mathematics and Statistics, The University of Sydney, http://hdl.handle.net/2123/13148, 2014.

# Unidata NetCDF

[![Build Status](https://travis-ci.org/Unidata/netcdf-c.svg?branch=master)](https://travis-ci.org/Unidata/netcdf-c)
[![Coverity Scan Build Status](https://scan.coverity.com/projects/157/badge.svg)](https://scan.coverity.com/projects/157)

### About
The Unidata network Common Data Form (**netCDF**) is an interface for
scientific data access and a freely-distributed software library that
provides an implementation of the interface.  The netCDF library also
defines a machine-independent format for representing scientific data.
Together, the interface, library, and format support the creation,
access, and sharing of scientific data.  The current netCDF software
provides C interfaces for applications and data.  Separate software
distributions available from Unidata provide Java, Fortran, Python,
and C++ interfaces.  They have been tested on various common
platforms.

#### Properties
NetCDF files are self-describing, network-transparent, directly
accessible, and extendible.  `Self-describing` means that a netCDF file
includes information about the data it contains.  `Network-transparent`
means that a netCDF file is represented in a form that can be accessed
by computers with different ways of storing integers, characters, and
floating-point numbers.  `Direct-access` means that a small subset of a
large dataset may be accessed efficiently, without first reading through
all the preceding data.  `Extendible` means that data can be appended to
a netCDF dataset without copying it or redefining its structure.

#### Use
NetCDF is useful for supporting access to diverse kinds of scientific
data in heterogeneous networking environments and for writing
application software that does not depend on application-specific
formats.  For information about a variety of analysis and display
packages that have been developed to analyze and display data in
netCDF form, see

* [Software for Manipulating or Displaying NetCDF Data](http://www.unidata.ucar.edu/netcdf/software.html)

##### More information
For more information about netCDF, see

* [Unidata Network Common Data Form (NetCDF)](http://www.unidata.ucar.edu/netcdf/)

### Latest releases
You can obtain a copy of the latest released version of netCDF
software for various languages:

* [C library and utilities](http://github.com/Unidata/netcdf-c)
* [Fortran](http://github.com/Unidata/netcdf-fortran)
* [Java](http://www.unidata.ucar.edu/downloads/netcdf/netcdf-java-4/)
* [Python](http://github.com/Unidata/netcdf4-python)
* [C++](http://github.com/Unidata/netcdf-cxx4)

### Copyright
Copyright and licensing information can be found [here](http://www.unidata.ucar.edu/software/netcdf/copyright.html), as well as in the COPYRIGHT file accompanying the software

### Installation
To install the netCDF-C software, please see the file INSTALL in the
netCDF-C distribution, or the (usually more up-to-date) document:

* [Building NetCDF](https://www.unidata.ucar.edu/software/netcdf/docs/winbin.html)

### Documentation
A language-independent User's Guide for netCDF, and some other
language-specific user-level documents are available from:

* [Language-independent User's Guide](http://www.unidata.ucar.edu/software/netcdf/docs/user_guide.html)
* [NetCDF-C Tutorial](http://www.unidata.ucar.edu/software/netcdf/docs/tutorial_8dox.html)
* [Fortran-90 User's Guide](http://www.unidata.ucar.edu/software/netcdf/documentation/historic/netcdf-f90/index.html#Top)
* [Fortran-77 User's Guide](http://www.unidata.ucar.edu/software/netcdf/documentation/historic/netcdf-f77/index.html#Top)
* [netCDF-Java/Common Data Model library](http://www.unidata.ucar.edu/software/thredds/current/netcdf-java/)
* [netCDF4-python](http://unidata.github.io/netcdf4-python/)

A mailing list, netcdfgroup@unidata.ucar.edu, exists for discussion of
the netCDF interface and announcements about netCDF bugs, fixes, and
enhancements.  For information about how to subscribe, see the URL

* [Unidata netCDF Mailing-Lists](http://www.unidata.ucar.edu/netcdf/mailing-lists.html)

### Feedback
We appreciate feedback from users of this package.  Please send comments, suggestions, and bug reports to <support-netcdf@unidata.ucar.edu>.  

! Copyright 2023 - David Minton
! This file is part of Cratermaker
! Cratermaker is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! cratermaker is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with cratermaker. 
! If not, see: https://www.gnu.org/licenses. 

module realistic
   use globals
   use bind

   interface
      pure module function realistic_perlin_noise_one(model, x, y, z, num_octaves, anchor, damp, damp0, damp_scale, freq, gain, gain0,&
                                            lacunarity, noise_height, pers, slope, warp, warp0) result(noise)
         implicit none
         character(len=*), intent(in) :: model !! The specific turbulence model to apply
         real(DP), intent(in) :: x, y, z  !! The xyz cartesian position of the noise to evaluate
         integer(I4B), intent(in) :: num_octaves
         real(DP), dimension(:,:), intent(in) :: anchor
         real(DP), intent(in) :: damp, damp0, damp_scale, freq, gain, gain0, lacunarity, noise_height, pers, slope, warp, warp0
         real(DP) :: noise
      end function realistic_perlin_noise_one


      module subroutine realistic_perlin_noise_all(model, x, y, z, num_octaves, anchor, damp, damp0, damp_scale, freq, gain, gain0,&
                                            lacunarity, noise_height, pers, slope, warp, warp0,noise)
         implicit none
         character(len=*), intent(in) :: model !! The specific turbulence model to apply
         real(DP), dimension(:), intent(in) :: x, y, z  !! The xyz cartesian position of the noise to evaluate
         integer(I4B), intent(in) :: num_octaves
         real(DP), dimension(:,:), intent(in) :: anchor
         real(DP), intent(in) :: damp, damp0, damp_scale, freq, gain, gain0, lacunarity, noise_height, pers, slope, warp, warp0
         real(DP), dimension(:), intent(out) :: noise
      end subroutine realistic_perlin_noise_all

   end interface

contains
   function bind_realistic_perlin_noise_one(c_model, x, y, z, num_octaves, c_anchor, damp, damp0, damp_scale, freq, gain, gain0, lacunarity, &
                                 noise_height, pers, slope, warp, warp0) bind(c) result(noise)
      ! Arguments
      character(kind=c_char), dimension(*), intent(in) :: c_model !! The specific turbulence model to apply
      real(DP), intent(in), value :: x, y, z  !! The xyz cartesian position of the noise to evaluate
      real(DP), intent(in), value :: damp, damp0, damp_scale, freq, gain, gain0, lacunarity, noise_height, pers, slope, warp, warp0
      integer(I4B), intent(in), value :: num_octaves
      type(c_ptr), intent(in), value :: c_anchor
      ! Return
      real(DP) :: noise
      ! Internals
      real(DP), dimension(:,:), pointer :: anchor
      character(len=STRMAX) :: model
      

      ! Convert from C-style string to Fortran-style
      call bind_c2f_string(c_model, model)
      if (c_associated(c_anchor)) then
         call c_f_pointer(c_anchor, anchor,shape=[3,num_octaves]) 
      else
         return
      end if

      noise = realistic_perlin_noise_one(model, x, y, z, num_octaves, anchor, damp, damp0, damp_scale, freq, gain, gain0, lacunarity, &
                                 noise_height, pers, slope, warp, warp0)
   end function bind_realistic_perlin_noise_one


   subroutine bind_realistic_perlin_noise_all(c_model, c_x, c_y, c_z, num_elements, num_octaves, c_anchor, damp, damp0, damp_scale, freq, &
                                 gain, gain0, lacunarity, noise_height, pers, slope, warp, warp0, c_noise) bind(c) 
      ! Arguments
      character(kind=c_char), dimension(*), intent(in) :: c_model !! The specific turbulence model to apply
      type(c_ptr), intent(in), value :: c_x, c_y, c_z  !! The xyz cartesian position of the noise to evaluate
      integer(I4B), intent(in), value :: num_elements, num_octaves
      real(DP), intent(in), value :: damp, damp0, damp_scale, freq, gain, gain0, lacunarity, noise_height, pers, slope, warp, warp0
      type(c_ptr), intent(in), value :: c_anchor
      type(c_ptr), intent(in), value :: c_noise
      ! Internals
      real(DP), dimension(:,:), pointer :: anchor
      real(DP), dimension(:), pointer :: x,y,z,noise
      character(len=STRMAX) :: model
      integer(I4B) :: i
      
      ! Convert from C-style string to Fortran-style
      call bind_c2f_string(c_model, model)
      if (c_associated(c_anchor)) then
         call c_f_pointer(c_anchor, anchor,shape=[3,num_octaves]) 
      else
         return
      end if

      if (c_associated(c_x)) then
         call c_f_pointer(c_x, x,shape=[num_elements]) 
      else
         return
      end if

      if (c_associated(c_y)) then
         call c_f_pointer(c_y, y,shape=[num_elements]) 
      else
         return
      end if

      if (c_associated(c_z)) then
         call c_f_pointer(c_z, z,shape=[num_elements]) 
      else
         return
      end if

      allocate(noise(num_elements))
      if (c_associated(c_noise)) then
         call c_f_pointer(c_noise, noise,shape=[num_elements]) 
      else
         return
      end if

      call realistic_perlin_noise_all(model, x, y, z, num_octaves, anchor, damp, damp0, damp_scale, freq, gain, gain0, lacunarity, &
                                 noise_height, pers, slope, warp, warp0, noise)

      return
   end subroutine bind_realistic_perlin_noise_all

end module realistic

! Copyright 2023 - David Minton
! This file is part of Cratermaker
! Cratermaker is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Cratermaker is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Cratermaker. 
! If not, see: https://www.gnu.org/licenses. 

submodule (ejecta) s_ejecta
    use globals
    integer(I4B), parameter :: Nraymax = 5 
        !! Maximum number of rays in a given pattern
    integer(I4B), parameter :: Npatt = 8 
        !! Number of different ray patterns
    real(DP), parameter :: frayreduction = 0.5_DP
        !! Factor by which to reduce the relative thickness of the ray for each subsequent pattern
    real(DP), parameter :: ejprofile = 3.0_DP 
        !! Ejecta profile power law index
contains

    module subroutine ejecta_distribution(radial_distance, initial_bearing, crater_diameter, ejrim, ejecta_truncation, dorays, &
                                            ejecta_thickness)
        !! author: David A. Minton
        !!
        !! Calculate the spatial distribution of ejecta in distal rays given a radial distance and initial bearing array.
        !! If dorays is true, calculate the ejecta distribution using the ray pattern. If false, use a homogenous power law profile.
        implicit none
        ! Arguments
        real(DP), dimension(:), intent(in) :: radial_distance
            !! Radial distance from the crater center in meters. 
        real(DP), dimension(:), intent(in) :: initial_bearing
            !! The initial bearing of the ray in radians.
        real(DP), intent(in) :: crater_diameter
            !! The final crater diameter in meters.
        real(DP), intent(in) :: ejrim 
            !! The final ejecta rim height in meters.
        real(DP), intent(in) :: ejecta_truncation
            !! The distance relative to the crater radius at which to truncate the ejecta pattern 
        logical(LGT), intent(in) :: dorays
            !! If true, calculate the ejecta distribution using the ray pattern. If false, use a homogenous power law profile.
        real(DP), dimension(:), intent(out) :: ejecta_thickness
            !! The thickness of the ejecta layer at each radial_distance, initial_bearing pair
        ! Internals
        real(DP) :: crater_radius
        integer(I4B) :: i, N

        N = size(radial_distance)

        if (dorays) then
            call ejecta_ray_intensity(radial_distance, initial_bearing, crater_diameter, ejecta_truncation, ejecta_thickness)
            crater_radius = crater_diameter / 2
            do concurrent (i = 1:N, radial_distance(i) >= crater_radius)
                ejecta_thickness(i) = ejecta_thickness(i) * ejecta_profile_func(radial_distance(i) / crater_radius, ejrim)
            end do
        else
            call ejecta_profile(radial_distance, crater_diameter, ejrim, ejecta_thickness)
        end if

        return
    end subroutine ejecta_distribution


    pure module subroutine ejecta_profile(radial_distance, crater_diameter, ejrim, ejecta_thickness)
        !! author: David A. Minton
        !!
        !! Calculate a homongenous power law profile of an ejecta blanket as a function of distance from the crater center.
        !! Follows the power law formula given by  McGetchin et al. (1973). 
        implicit none
        ! Arguments
        real(DP),dimension(:), intent(in) :: radial_distance  
            !! Radial distance from the crater center in meters. 
        real(DP), intent(in) :: crater_diameter 
            !! The final crater diameter in meters.
        real(DP), intent(in) :: ejrim 
            !! The final ejecta rim height in meters.
        real(DP), dimension(:), intent(out) :: ejecta_thickness 
            !! The thicknes of the ejecta relativ
        ! Internals
        real(DP) :: r, crater_radius

        ! Calculate the floor radius relative to the final crater radius
        crater_radius = crater_diameter / 2

        where(radial_distance(:) >= crater_radius)
            ejecta_thickness(:) = ejecta_profile_func(radial_distance(:) / crater_radius, ejrim)
        elsewhere
            ejecta_thickness(:) = 0.0_DP
        end where

        return         
    end subroutine ejecta_profile


    pure elemental function ejecta_profile_func(r, ejrim) result(h)
        !! author: David A. Minton
        !!
        !! Calculate the thickness of the ejecta layer as a function of distance from the center.
        !!                                
        implicit none
        ! Arguments
        real(DP), intent(in) :: r 
            !! Radial distance from the crater centerin meters. 
        real(DP), intent(in) :: ejrim
            !! The final ejecta rim height 
        real(DP) :: h
            !! The ejecta thickness at the given radial distance 

        h = ejrim * (r)**(-ejprofile)

    end function ejecta_profile_func


    module subroutine ejecta_ray_intensity(radial_distance, initial_bearing, crater_diameter, ejecta_truncation, intensity)
        !! author: David A. Minton
        !!
        !! Calculate the spatial distribution of ejecta in distal rays given a radial distance and initial bearing array.
        implicit none
        ! Arguments
        real(DP), dimension(:), intent(in) :: radial_distance
            !! Radial distance from the crater center in meters. 
        real(DP), dimension(:), intent(in) :: initial_bearing
            !! The initial bearing of the ray in radians.
        real(DP), intent(in) :: crater_diameter
            !! The final crater diameter in meters.
        real(DP), intent(in) :: ejecta_truncation
            !! The distance relative to the crater radius at which to truncate the ejecta pattern 
        real(DP), dimension(:), intent(out) :: intensity
            !! The intensity value of the ray pattern at each radial_distance, initial_bearing pair

        ! Internals
        real(DP) :: minray, rmax, rmin, theta, crater_radius
        real(DP), dimension(Nraymax) :: thetari
        real(DP), dimension(Npatt)   :: rn, ray_pattern_intensity
        real(DP) :: r_pattern
        integer(I4B) :: i, j, N

        N = size(radial_distance)
        if (size(initial_bearing) /= N) then
            print *, "Error: initial_bearing and radial_distance arrays must be the same size."
            stop
        end if
        crater_radius = crater_diameter / 2
        rmax = ejecta_truncation
        rmin = 1.0_DP 
        minray = 2.348_DP * crater_radius**(0.006_DP)  ! The continuous ejecta blanket radius relative to the crater radius

        ! Distribute ray patterns evenly around the crater
        do concurrent (i = 1:Nraymax)
            thetari(i) = 2 * pi * i / Nraymax
        end do
        call shuffle(thetari) ! randomize the ray pattern so that the ray lengths are randomly distributed
        call random_number(rn) ! randomize the ray orientation

        where(radial_distance(:) < crater_radius)
            intensity(:) = 0.0_DP
        endwhere

        do concurrent (i = 1:N, radial_distance(i) >= crater_radius)
            ! Layer the ray patterns on top of each other
            do concurrent (j = 1:Npatt)
                theta = mod(initial_bearing(i) + rn(j) * 2 * PI, 2 * PI)

                ! Make a slight random adjustment to the r values so that the indivdual rays on different patterns 
                r_pattern = radial_distance(i) / crater_radius - rn(j)
                ray_pattern_intensity(j) = frayreduction**(j-1) * ejecta_ray_intensity_func(r_pattern,theta,rmin,rmax,thetari, &
                                                                                                minray)
            end do
            intensity(i) = sum(ray_pattern_intensity(:)) 
        end do

        ! Normalize the intensity values so they span from 0 to 1
        where(radial_distance(:) >= crater_radius)
            intensity(:) = intensity(:) / maxval(intensity(:))
        end where

        contains
            subroutine shuffle(a)
                real(DP), intent(inout) :: a(:)
                integer :: i, randpos
                real(DP) :: r,temp
             
                do i = size(a), 2, -1
                    call random_number(r)
                    randpos = int(r * i) + 1
                    temp = a(randpos)
                    a(randpos) = a(i)
                    a(i) = temp
                end do
                return
           end subroutine shuffle

    end subroutine ejecta_ray_intensity


    pure function ejecta_ray_intensity_func(r,theta,rmin,rmax,thetari,minray) result(ans)
        !! author: David A. Minton
        !!
        !! Calculate the spatial distribution of ejecta in distal rays.
        implicit none
        ! Arguments
        real(DP),intent(in) :: r,theta,rmin,rmax
        real(DP),dimension(:),intent(in) :: thetari
        real(DP),intent(in) :: minray
        ! Result
        real(DP) :: ans
        ! Internals
        real(DP) :: thetar,rw, w
        real(DP) :: length,minray,FF
        integer(I4B) :: n,i
        real(DP) :: tmp
        real(DP), parameter :: rayp = 4.0_DP ! Factor that controls how the lengths of rays are distributed
     
        if (r > rmax) then
            ans = 0._DP
        else if (r < 1.0_DP) then
            ans = 1.0_DP
        else
            tmp = (Nraymax**rayp - (Nraymax**rayp - 1) * log(r/minray) / log(rmax/minray))
            if (tmp < 0.0_DP) then
               n = Nraymax ! "Nrays" in Minton et al. (2019)
            else ! Exponential decay of ray number with distance
               n = max(min(floor((Nraymax**rayp - (Nraymax**rayp - 1) * log(r/minray) / log(rmax/minray))**(1._DP/rayp)),Nraymax),1)
            end if
            ans = 0._DP
            do i = 1,Nraymax
                length = minray * exp(log(rmax/minray) * ((Nraymax - i + 1)**rayp - 1.0_DP) / ((Nraymax**rayp - 1)))
                if (r > length) cycle ! Don't add any material beyond the length of the ray
                w = (rmax / length) ** (1.0_DP)
                ! equation 41 Minton et al. 2019
                rw = PI / (w * Nraymax) * (rmin / r) * (1._DP - (1.0_DP - w / rmin) * exp(1._DP - (r / rmin)**2)) 
                tmp = ejecta_ray_func(theta,thetari(i),r,n,rw) 
                if (tmp > epsilon(ans)) ans = ans + tmp  ! Ensure that we don't get an underflow
           end do
        end if

        return
    end function ejecta_ray_intensity_func 

    
    pure function ejecta_ray_func(theta,thetar,r,n,w) result(ans)
        !! author: David A. Minton
        !!
        !! Calculate the spatial distribution of ejecta in a single ray. The intensity function is a Gaussian centered on the 
        !! midline of the ray.
        implicit none
        real(DP) :: ans
        real(DP),intent(in) :: theta,thetar,r,w
        integer(I4B),intent(in) :: n
        real(DP) :: thetap,thetapp,a,b,c,dtheta,logval
    
        c = w / r
        b = thetar 
        dtheta = min(2*pi - abs(theta - b),abs(theta - b))
        logval = -dtheta**2 / (2 * c**2)
        if (logval < LOGVSMALL) then
            ans = 0.0_DP
        else
            a = sqrt(2 * pi) / (n * c * erf(pi / (2 *sqrt(2._DP) * c))) 
            ans = a * exp(logval)
        end if
    
        return
    end function ejecta_ray_func
end submodule s_ejecta

! Copyright 2024 - David Minton
! This file is part of Cratermaker
! Cratermaker is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! cratermaker is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with cratermaker. 
! If not, see: https://www.gnu.org/licenses. 

module ejecta
    use globals
    use bind
 
    interface
        module subroutine ejecta_distribution(radial_distance, initial_bearing, crater_diameter, ejrim, ejecta_truncation, dorays, &
            ejecta_thickness)
            implicit none
            real(DP), dimension(:), intent(in) :: radial_distance
            real(DP), dimension(:), intent(in) :: initial_bearing
            real(DP), intent(in) :: crater_diameter
            real(DP), intent(in) :: ejrim 
            real(DP), intent(in) :: ejecta_truncation
            logical(LGT), intent(in) :: dorays
            real(DP), dimension(:), intent(out) :: ejecta_thickness
        end subroutine ejecta_distribution

         pure module subroutine ejecta_profile(radial_distance, crater_diameter, ejrim, ejecta_thickness)
             implicit none
             real(DP),dimension(:), intent(in) :: radial_distance
             real(DP), intent(in) :: crater_diameter, ejrim
             real(DP), dimension(:), intent(out) :: ejecta_thickness
         end subroutine ejecta_profile

         module subroutine ejecta_ray_intensity(radial_distance, initial_bearing, crater_diameter, ejecta_truncation, intensity)
             implicit none
             real(DP), dimension(:), intent(in) :: radial_distance, initial_bearing
             real(DP), intent(in) :: crater_diameter, ejecta_truncation
             real(DP), dimension(:), intent(out) :: intensity
         end subroutine ejecta_ray_intensity

    end interface

contains
    subroutine bind_ejecta_distribution(c_radial_distance, c_initial_bearing, num_elements, crater_diameter, ejrim, &
                                       ejecta_truncation, dorays, c_ejecta_thickness) bind(c)
        ! Argumentsdistribution
        type(c_ptr), intent(in), value :: c_radial_distance, c_initial_bearing
        integer(I4B), intent(in), value :: num_elements
        real(DP), intent(in), value :: crater_diameter, ejrim, ejecta_truncation
        logical(LGT), intent(in), value :: dorays
        type(c_ptr), intent(in), value :: c_ejecta_thickness
        ! Internals
        real(DP), dimension(:), pointer :: radial_distance, initial_bearing, ejecta_thickness

        if (c_associated(c_radial_distance)) then
            call c_f_pointer(c_radial_distance, radial_distance, shape=[num_elements]) 
        else
            return
        end if

        if (c_associated(c_initial_bearing)) then
            call c_f_pointer(c_initial_bearing, initial_bearing, shape=[num_elements]) 
        else
            return
        end if

        allocate(ejecta_thickness(num_elements))
        if (c_associated(c_ejecta_thickness)) then
            call c_f_pointer(c_ejecta_thickness, ejecta_thickness,shape=[num_elements]) 
        else
            return
        end if

        call ejecta_distribution(radial_distance, initial_bearing, crater_diameter, ejrim, ejecta_truncation, dorays, &
                                     ejecta_thickness)
 
        return
    end subroutine bind_ejecta_distribution


    subroutine bind_ejecta_profile(c_radial_distance, num_elements, crater_diameter, ejrim, c_ejecta_thickness) bind(C)
        ! Arguments
        type(c_ptr), intent(in), value :: c_radial_distance
        integer(I4B), intent(in), value :: num_elements
        real(DP), intent(in), value :: crater_diameter, ejrim
        type(c_ptr), intent(in), value :: c_ejecta_thickness
        ! Internals
        real(DP), dimension(:), pointer :: radial_distance,ejecta_thickness
        integer(I4B) :: i
       
        if (c_associated(c_radial_distance)) then
            call c_f_pointer(c_radial_distance, radial_distance,shape=[num_elements]) 
        else
            return
        end if
 
        allocate(ejecta_thickness(num_elements))
        if (c_associated(c_ejecta_thickness)) then
            call c_f_pointer(c_ejecta_thickness, ejecta_thickness, shape=[num_elements]) 
        else
            return
        end if
 
        call ejecta_profile(radial_distance, crater_diameter, ejrim, ejecta_thickness)

        return
    end subroutine bind_ejecta_profile


    subroutine bind_ejecta_ray_intensity(c_radial_distance, c_initial_bearing, num_elements, crater_diameter, &
                                       ejecta_truncation, c_intensity) bind(c)
        ! Arguments
        type(c_ptr), intent(in), value :: c_radial_distance, c_initial_bearing
        integer(I4B), intent(in), value :: num_elements
        real(DP), intent(in), value :: crater_diameter, ejecta_truncation
        type(c_ptr), intent(in), value :: c_intensity
        ! Internals
        real(DP), dimension(:), pointer :: radial_distance, initial_bearing, intensity

        if (c_associated(c_radial_distance)) then
            call c_f_pointer(c_radial_distance, radial_distance, shape=[num_elements]) 
        else
            return
        end if

        if (c_associated(c_initial_bearing)) then
            call c_f_pointer(c_initial_bearing, initial_bearing, shape=[num_elements]) 
        else
            return
        end if

        allocate(intensity(num_elements))
        if (c_associated(c_intensity)) then
            call c_f_pointer(c_intensity, intensity,shape=[num_elements]) 
        else
            return
        end if

        call ejecta_ray_intensity(radial_distance, initial_bearing, crater_diameter, ejecta_truncation, intensity) 
 
        return
    end subroutine bind_ejecta_ray_intensity
end module ejecta

! Copyright 2023 - David Minton
! This file is part of Cratermaker
! Cratermaker is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Cratermaker is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Cratermaker. 
! If not, see: https://www.gnu.org/licenses. 

!! The implementations for the Perlin noise procedures.
submodule (morphology_module) s_morphology
    use globals_module
contains

   module pure subroutine morphology_profile(radial_distance, reference_elevation, diameter, floordepth, floordiam, &
      rimheight, ejrim, RIMDROP, elevation)
      !! author: David A. Minton
      !!
      !! Calculate the elevation of a crater as a function of distance from the center.
      !!
      implicit none
      ! Arguments
      real(DP),dimension(:), intent(in) :: radial_distance  !! Radial distance from the crater center in meters. 
      real(DP),dimension(:), intent(in) :: reference_elevation !! The elevation of the reference surface at the radial distance r.
      real(DP), intent(in) :: diameter !! The final crater diameter in meters.
      real(DP), intent(in) :: floordepth !! The final crater floor depth in meters.
      real(DP), intent(in) :: floordiam !! The final crater floor diameter in meters.
      real(DP), intent(in) :: rimheight !! The final crater rim height in meters.
      real(DP), intent(in) :: ejrim !! The final ejecta rim height in meters.
      real(DP), intent(in) :: RIMDROP !! The exponent for the ejecta rim dropoff.
      real(DP), dimension(:), intent(out) :: elevation !! The elevation of the crater relative to a reference surface.
      ! Internals
      integer(I4B) :: i, ninc
      real(DP) :: r, flrad, radius, meanref, min_elevation
      real(DP) :: c0, c1, c2, c3
      real(DP), parameter :: A = 4.0_DP / 11.0_DP
      real(DP), parameter :: B = -32.0_DP / 187.0_DP
      real(DP), parameter :: ejprofile = 3.0_DP

      ! Calculate the floor radius relative to the final crater radius
      flrad = floordiam / diameter
      radius = diameter / 2

      ! Use polynomial crater profile similar to that of Fassett et al. (2014), but the parameters are set by the crater dimensions
      c1 = (-floordepth - rimheight) / (flrad - 1.0_DP + A * (flrad**2 - 1.0_DP) + B * (flrad**3 - 1.0_DP))
      c0 = rimheight - c1 * (1.0_DP + A + B)
      c2 = A * c1
      c3 = B * c1
      ninc = count(radial_distance(:) <= radius)
      if (ninc == 0) then
         meanref = reference_elevation(minloc(radial_distance(:),dim=1))
      else
         meanref = sum(reference_elevation(:), radial_distance(:) <= radius) / ninc
      end if
      min_elevation = meanref - floordepth

      elevation(:) = reference_elevation(:) + crater_profile(radial_distance(:)/radius)
      where(radial_distance(:) >= radius)
         elevation(:) = elevation(:) + ejecta_profile(radial_distance(:)/radius)
      elsewhere(elevation(:) < min_elevation)
         elevation(:) = min_elevation
      end where

      return         

      contains

         pure elemental function crater_profile(r) result(h)
            !! author: David A. Minton
            !!
            !! Calculate the elevation of a crater as a function of distance from the center.
            !!                                
            implicit none
            ! Arguments
            real(DP), intent(in) :: r !! Radial distance from the crater center in meters. 

            ! Results
            real(DP) :: h

            if (r >= 1.0_DP) then
               h = (rimheight - ejrim) * (r**(-RIMDROP))
            else
               h = c0 + c1 * r + c2 * r**2 + c3 * r**3
            end if

         end function crater_profile

         pure elemental function ejecta_profile(r) result(h)
            !! author: David A. Minton
            !!
            !! Calculate the elevation of the ejecta layer as a function of distance from the center.
            !!                                
            implicit none
            ! Arguments
            real(DP), intent(in) :: r !! Radial distance from the crater center in meters. 

            ! Results
            real(DP) :: h

            h = ejrim * (r)**(-ejprofile)

         end function ejecta_profile

   end subroutine morphology_profile

end submodule s_morphology

! Copyright 2023 - David Minton
! This file is part of Cratermaker
! Cratermaker is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Cratermaker is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Cratermaker. 
! If not, see: https://www.gnu.org/licenses. 

!! The implementations for the Perlin noise procedures.
submodule (crater) s_crater
    use globals
    use ejecta
contains

    pure module subroutine crater_profile(radial_distance, reference_elevation, diameter, floordepth, floordiam, &
        rimheight, ejrim, elevation)
        !! author: David A. Minton
        !!
        !! Calculate the elevation of a crater as a function of distance from the center.
        !!
        implicit none
        ! Arguments
        real(DP),dimension(:), intent(in) :: radial_distance  
            !! Radial distance from the crater center in meters. 
        real(DP),dimension(:), intent(in) :: reference_elevation 
            !! The elevation of the reference surface at the radial distance r.
        real(DP), intent(in) :: diameter 
            !! The final crater diameter in meters.
        real(DP), intent(in) :: floordepth 
            !! The final crater floor depth in meters.
        real(DP), intent(in) :: floordiam 
            !! The final crater floor diameter in meters.
        real(DP), intent(in) :: rimheight 
            !! The final crater rim height in meters.
        real(DP), intent(in) :: ejrim 
            !! The final ejecta rim height in meters.
        real(DP), dimension(:), intent(out) :: elevation 
            !! The elevation of the crater relative to a reference surface.
        ! Internals
        integer(I4B) :: i, ninc
        real(DP) :: r, flrad, radius, meanref, min_elevation
        real(DP) :: c0, c1, c2, c3
        real(DP), parameter :: A = 4.0_DP / 11.0_DP
        real(DP), parameter :: B = -32.0_DP / 187.0_DP
        real(DP), parameter :: RIMDROP = 4.20_DP ! The exponent for the uplifted rim dropoff.
  
        ! Calculate the floor radius relative to the final crater radius
        flrad = floordiam / diameter
        radius = diameter / 2
  
        ! Use polynomial crater profile similar to that of Fassett et al. (2014), but the parameters are set by the crater dimensions
        c1 = (-floordepth - rimheight) / (flrad - 1.0_DP + A * (flrad**2 - 1.0_DP) + B * (flrad**3 - 1.0_DP))
        c0 = rimheight - c1 * (1.0_DP + A + B)
        c2 = A * c1
        c3 = B * c1
        ninc = count(radial_distance(:) <= radius)
        if (ninc == 0) then
            meanref = reference_elevation(minloc(radial_distance(:),dim=1))
        else
            meanref = sum(reference_elevation(:), radial_distance(:) <= radius) / ninc
        end if
        min_elevation = meanref - floordepth
  
        elevation(:) = reference_elevation(:) + crater_profile_func(radial_distance(:)/radius)
        where((radial_distance(:) <= radius).and.(elevation(:) < min_elevation))
            elevation(:) = min_elevation
        end where
  
        return         
  
        contains
 
            pure elemental function crater_profile_func(r) result(h)
                !! author: David A. Minton
                !!
                !! Calculate the elevation of a crater as a function of distance from the center.
                !!                                
                implicit none
                ! Arguments
                real(DP), intent(in) :: r 
                    !! Radial distance from the crater center in meters. 
    
                ! Results
                real(DP) :: h
    
                if (r >= 1.0_DP) then
                    h = (rimheight - ejrim) * (r**(-RIMDROP))
                else
                    h = c0 + c1 * r + c2 * r**2 + c3 * r**3
                end if
                return
            end function crater_profile_func

    end subroutine crater_profile
end submodule s_crater

! Copyright 2023 - David Minton
! This file is part of Cratermaker
! Cratermaker is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Cratermaker is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Cratermaker. 
! If not, see: https://www.gnu.org/licenses. 

!! The type definition for the surface object and interfaces for the surface module procedures.
module surface_module
   use globals_module

   type  :: surface_type 
      real(DP), dimension(:), allocatable :: elevation !! Elevation of surface mesh relative to the datum
      real(DP), dimension(:), allocatable :: node_x    !! Cartesian position of the nodes in the x-direction
      real(DP), dimension(:), allocatable :: node_y    !! Cartesian position of the nodes in the y-direction
      real(DP), dimension(:), allocatable :: node_z    !! Cartesian position of the nodes in the z-direction
      real(DP), dimension(:), allocatable :: face_x    !! Cartesian position of the faces in the x-direction
      real(DP), dimension(:), allocatable :: face_y    !! Cartesian position of the faces in the y-direction
      real(DP), dimension(:), allocatable :: face_z    !! Cartesian position of the faces in the z-direction
   contains
      procedure :: allocate   => surface_allocate   !! Allocate the allocatable components of the class
      procedure :: deallocate => surface_deallocate !! Deallocate all allocatable components of the class
      final     ::               surface_final      !! Finalizer (calls deallocate)
   end type surface_type


contains

   subroutine surface_allocate(self, n_node, n_face)
      !! author: David A. Minton
      !!
      !! Allocate the allocatable components of the class
      implicit none
      ! Arguments
      class(surface_type), intent(inout) :: self   !! Simulation object
      integer(I4B),        intent(in)    :: n_node !! Number of nodes in the surface mesh
      integer(I4B),        intent(in)    :: n_face !! Number of faces in the surface mesh

      allocate(self%elevation(n_node))
      allocate(self%node_x(n_node))
      allocate(self%node_y(n_node))
      allocate(self%node_z(n_node))
      allocate(self%face_x(n_face))
      allocate(self%face_y(n_face))
      allocate(self%face_z(n_face))

      self%elevation(:) = 0.0_DP
      self%node_x(:)    = 0.0_DP
      self%node_y(:)    = 0.0_DP
      self%node_z(:)    = 0.0_DP
      self%face_x(:)    = 0.0_DP
      self%face_y(:)    = 0.0_DP
      self%face_z(:)    = 0.0_DP

      return
   end subroutine surface_allocate


   subroutine surface_deallocate(self) 
      !! author: David A. Minton
      !!
      !! Deallocate the allocatable components of the class
      implicit none
      ! Arguments
      class(surface_type), intent(inout) :: self !! Surface object

      deallocate(self%elevation)
      deallocate(self%node_x)
      deallocate(self%node_y)
      deallocate(self%node_z)
      deallocate(self%face_x)
      deallocate(self%face_y)
      deallocate(self%face_z)

      return
   end subroutine surface_deallocate


   subroutine surface_final(self)
      !! author: David A. Minton
      !!
      !! Finalizer for the surface object
      implicit none
      ! Arguments
      type(surface_type), intent(inout) :: self

      call self%deallocate()
      return
   end subroutine surface_final


end module surface_module

! Copyright 2023 - David Minton
! This file is part of Cratermaker
! Cratermaker is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Cratermaker is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Cratermaker. 
! If not, see: https://www.gnu.org/licenses. 

!! Interfaces for the Cython-Fortran bindings.
module bind_module
   !! author: David A. Minton
   !!
   !! This module defines the set of routines that connect the Cython code to the Fortran. Because Fortran derived types with
   !! allocatable arrays and type-bound procedures are not interoperable with C, you have to write a set of functions that allow
   !! you to access the Fortran structures. On the Fortran side, you can make use of the full suite of OOF features from F2003+ 
   !! e.g. classes, inheritence, polymorphism, type-bound procedures, etc., but any communication back to Python must be done 
   !! via a set of binding functions. 
   !! 
   !! The following implementation was adapted from _Modern Fortran Explained: Incorporating Fortran 2018_ by Metcalf, Reid, & 
   !! Cohen (see Fig. 19.8)
   use iso_c_binding
   use globals_module
   use surface_module
   implicit none
   
contains

   type(c_ptr) function bind_surface_init(n_node,n_face) bind(c)
      !! author: David A. Minton
      !!
      !! This function is used to initialize the surface_type derived type object in Fortran and return a pointer to the object 
      !! that can be used as a struct in C, and ultimately to the Python class object via Cython.
      implicit none
      ! Arguments
      integer(I4B), intent(in), value   :: n_node !! The number of nodes in the surface mesh
      integer(I4B), intent(in), value   :: n_face !! The number of faces in the surface mesh
      ! Internals
      type(surface_type), pointer :: f_surf !! A pointer to the surface_type variable that will be passed to Cython

      nullify(f_surf)
      allocate(f_surf)
      call f_surf%allocate(n_node, n_face)
      bind_surface_init = c_loc(f_surf)

      return
   end function bind_surface_init


   subroutine bind_surface_final(sim) bind(c)
      !! author: David A. Minton
      !!
      !! This subroutine is used to deallocate the pointer that links the C struct to the Fortran derived type object. 
      implicit none
      ! Arguments
      type(c_ptr), intent(in), value :: sim !! C pointer to the Fortran body object
      ! Internals
      type(surface_type), pointer :: f_surf

      if (c_associated(sim)) then
         call c_f_pointer(sim, f_surf)
         deallocate(f_surf)
      end if

      return
   end subroutine bind_surface_final


   subroutine bind_c2f_string(c_string, f_string) 
      !! author: David A. Minton
      !!
      !! This subroutine is used to convert C style strings into Fortran. This allows one to pass Python strings as arguments to 
      !! Fortran functions.
      implicit none
      ! Arguments
      character(kind=c_char), dimension(*), intent(in)  :: c_string  !! Input C-style string
      character(len=STRMAX),                intent(out) :: f_string  !! Output Fortran-style string
      ! Internals
      integer :: i
      character(len=STRMAX,kind=c_char) :: tmp_string

      i=1
      tmp_string = ''
      do while(c_string(i) /= c_null_char .and. i <= STRMAX)
         tmp_string(i:i) = c_string(i)
         i=i+1
      end do

      if (i > 1) then
         f_string = trim(tmp_string)
      else
         f_string = ""
      end if

      return
   end subroutine bind_c2f_string


   subroutine bind_f2c_string(f_string, c_string)
      !! author: David A. Minton
      !!
      !! This subroutine is used to convert Fortran style strings to C. This allows the Python module to read strings that were 
      !! created in Fortran procedures.
      implicit none
      ! Arguments
      character(len=*), intent(in) :: f_string  !! Input Fortran-style string
      character(kind=c_char), dimension(STRMAX), target, intent(out) :: c_string  !! Output C-style string (array of C characters)
      ! Internals 
      integer :: n, i

      n = min(len(f_string), STRMAX-1)
      do i = 1, n
         c_string(i) = f_string(i:i)
      end do
      c_string(n + 1) = c_null_char
   end subroutine bind_f2c_string


end module bind_module

! Copyright 2023 - David Minton
! This file is part of Cratermaker
! Cratermaker is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! cratermaker is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with cratermaker. 
! If not, see: https://www.gnu.org/licenses. 

!! The interfaces for the Perlin noise routines.
module perlin_module
   use globals_module
   use bind_module

   interface
      module pure elemental subroutine perlin_noise(xx, yy, zz, noise, dx, dy, dz)
         implicit none
         real(DP),intent(in) :: xx,yy,zz
         real(DP),intent(out) :: noise
         real(DP),intent(out),optional :: dx, dy, dz
      end subroutine perlin_noise


      module pure function perlin_turbulence(x, y, z, noise_height, freq, pers, num_octaves, anchor) result(noise)
         implicit none
         real(DP), intent(in) ::  x, y, z, noise_height, freq, pers
         integer(I4B), intent(in) :: num_octaves
         real(DP), dimension(:,:),intent(in) :: anchor
         real(DP) :: noise
      end function perlin_turbulence
   
   
      module pure function perlin_billowedNoise(x, y, z, noise_height, freq, pers, num_octaves, anchor) result(noise)
         implicit none
         real(DP), intent(in) ::  x, y, z, noise_height, freq, pers
         integer(I4B), intent(in) :: num_octaves
         real(DP),dimension(:,:),intent(in) :: anchor
         real(DP) :: noise
      end function perlin_billowedNoise
         
         
      module pure function perlin_plawNoise(x, y, z, noise_height, freq, pers, slope, num_octaves, anchor) result(noise)
         implicit none
         real(DP), intent(in) ::  x, y, z, noise_height, freq, pers,slope
         integer(I4B), intent(in) :: num_octaves
         real(DP),dimension(:,:),intent(in) :: anchor
         real(DP) :: noise
      end function perlin_plawNoise
         
         
      module pure function perlin_ridgedNoise(x, y, z, noise_height, freq, pers, num_octaves, anchor) result(noise)
         implicit none
         real(DP), intent(in) ::  x, y, z, noise_height, freq, pers
         integer(I4B), intent(in) :: num_octaves
         real(DP),dimension(:,:),intent(in) :: anchor
         real(DP) :: noise
      end function perlin_ridgedNoise
         
         
      module pure function perlin_swissTurbulence(x, y, z, lacunarity, gain, warp, num_octaves, anchor) result(noise)
         implicit none
         real(DP), intent(in) ::  x, y, z, lacunarity, gain, warp
         integer(I4B), intent(in) :: num_octaves
         real(DP),dimension(:,:), intent(in) :: anchor
         real(DP) :: noise
      end function perlin_swissTurbulence
      
         
      module pure function perlin_jordanTurbulence(x, y, z, lacunarity, gain0, gain, warp0, warp, damp0, damp, damp_scale,&
               num_octaves, anchor) result(noise)
         implicit none
         real(DP),intent(in) :: x, y, z, lacunarity, gain0, gain, warp0, warp, damp0, damp, damp_scale
         integer(I4B),intent(in) :: num_octaves
         real(DP), dimension(:,:), intent(in) :: anchor
         real(DP) :: noise
      end function perlin_jordanTurbulence

      module pure function perlin_noise_one(model, x, y, z, num_octaves, anchor, damp, damp0, damp_scale, freq, gain, gain0,&
                                            lacunarity, noise_height, pers, slope, warp, warp0) result(noise)
         implicit none
         character(len=*), intent(in) :: model !! The specific turbulence model to apply
         real(DP), intent(in) :: x, y, z  !! The xyz cartesian position of the noise to evaluate
         integer(I4B), intent(in) :: num_octaves
         real(DP), dimension(:,:), intent(in) :: anchor
         real(DP), intent(in) :: damp, damp0, damp_scale, freq, gain, gain0, lacunarity, noise_height, pers, slope, warp, warp0
         real(DP) :: noise
      end function perlin_noise_one


      module subroutine perlin_noise_all(model, x, y, z, num_octaves, anchor, damp, damp0, damp_scale, freq, gain, gain0,&
                                            lacunarity, noise_height, pers, slope, warp, warp0,noise)
         implicit none
         character(len=*), intent(in) :: model !! The specific turbulence model to apply
         real(DP), dimension(:), intent(in) :: x, y, z  !! The xyz cartesian position of the noise to evaluate
         integer(I4B), intent(in) :: num_octaves
         real(DP), dimension(:,:), intent(in) :: anchor
         real(DP), intent(in) :: damp, damp0, damp_scale, freq, gain, gain0, lacunarity, noise_height, pers, slope, warp, warp0
         real(DP), dimension(:), intent(out) :: noise
      end subroutine perlin_noise_all


         
   end interface

contains
   function bind_perlin_noise_one(c_model, x, y, z, num_octaves, c_anchor, damp, damp0, damp_scale, freq, gain, gain0, lacunarity, &
                                 noise_height, pers, slope, warp, warp0) bind(c) result(noise)
      ! Arguments
      character(kind=c_char), dimension(*), intent(in) :: c_model !! The specific turbulence model to apply
      real(DP), intent(in), value :: x, y, z  !! The xyz cartesian position of the noise to evaluate
      real(DP), intent(in), value :: damp, damp0, damp_scale, freq, gain, gain0, lacunarity, noise_height, pers, slope, warp, warp0
      integer(I4B), intent(in), value :: num_octaves
      type(c_ptr), intent(in), value :: c_anchor
      ! Return
      real(DP) :: noise
      ! Internals
      real(DP), dimension(:,:), pointer :: anchor
      character(len=STRMAX) :: model
      

      ! Convert from C-style string to Fortran-style
      call bind_c2f_string(c_model, model)
      if (c_associated(c_anchor)) then
         call c_f_pointer(c_anchor, anchor,shape=[3,num_octaves]) 
      else
         return
      end if

      noise = perlin_noise_one(model, x, y, z, num_octaves, anchor, damp, damp0, damp_scale, freq, gain, gain0, lacunarity, &
                                 noise_height, pers, slope, warp, warp0)
   end function bind_perlin_noise_one


   subroutine bind_perlin_noise_all(c_model, c_x, c_y, c_z, num_elements, num_octaves, c_anchor, damp, damp0, damp_scale, freq, &
                                 gain, gain0, lacunarity, noise_height, pers, slope, warp, warp0, c_noise) bind(c) 
      ! Arguments
      character(kind=c_char), dimension(*), intent(in) :: c_model !! The specific turbulence model to apply
      type(c_ptr), intent(in), value :: c_x, c_y, c_z  !! The xyz cartesian position of the noise to evaluate
      integer(I4B), intent(in), value :: num_elements, num_octaves
      real(DP), intent(in), value :: damp, damp0, damp_scale, freq, gain, gain0, lacunarity, noise_height, pers, slope, warp, warp0
      type(c_ptr), intent(in), value :: c_anchor
      type(c_ptr), intent(in), value :: c_noise
      ! Internals
      real(DP), dimension(:,:), pointer :: anchor
      real(DP), dimension(:), pointer :: x,y,z,noise
      character(len=STRMAX) :: model
      integer(I4B) :: i
      
      ! Convert from C-style string to Fortran-style
      call bind_c2f_string(c_model, model)
      if (c_associated(c_anchor)) then
         call c_f_pointer(c_anchor, anchor,shape=[3,num_octaves]) 
      else
         return
      end if

      if (c_associated(c_x)) then
         call c_f_pointer(c_x, x,shape=[num_elements]) 
      else
         return
      end if

      if (c_associated(c_y)) then
         call c_f_pointer(c_y, y,shape=[num_elements]) 
      else
         return
      end if

      if (c_associated(c_z)) then
         call c_f_pointer(c_z, z,shape=[num_elements]) 
      else
         return
      end if

      allocate(noise(num_elements))
      if (c_associated(c_noise)) then
         call c_f_pointer(c_noise, noise,shape=[num_elements]) 
      else
         return
      end if

      call perlin_noise_all(model, x, y, z, num_octaves, anchor, damp, damp0, damp_scale, freq, gain, gain0, lacunarity, &
                                 noise_height, pers, slope, warp, warp0, noise)

      return
   end subroutine bind_perlin_noise_all

end module perlin_module

! Copyright 2024 - David Minton
! This file is part of Cratermaker
! Cratermaker is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! cratermaker is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with cratermaker. 
! If not, see: https://www.gnu.org/licenses. 

!! The interfaces for the Perlin noise routines.
module morphology_module
   use globals_module
   use bind_module

   interface
      module pure subroutine morphology_profile(radial_distance, reference_elevation, diameter, &
         floordepth, floordiam, rimheight, ejrim, RIMDROP, elevation)
         implicit none
         real(DP),dimension(:), intent(in) :: radial_distance, reference_elevation
         real(DP), intent(in) :: diameter, floordepth, floordiam, rimheight, ejrim, RIMDROP
         real(DP), dimension(:), intent(out) :: elevation
      end subroutine morphology_profile
   end interface

contains
   subroutine bind_morphology_profile(c_radial_distance, c_reference_elevation, num_elements, diameter, &
                                             floordepth, floordiam, rimheight, ejrim, RIMDROP, c_elevation)  &
                                             bind(C)
      ! Arguments
      type(c_ptr), intent(in), value :: c_radial_distance, c_reference_elevation
      integer(I4B), intent(in), value :: num_elements
      real(DP), intent(in), value :: diameter, floordepth, floordiam, rimheight, ejrim, RIMDROP
      type(c_ptr), intent(in), value :: c_elevation
      ! Internals
      real(DP), dimension(:), pointer :: radial_distance,reference_elevation,elevation
      integer(I4B) :: i
      
      if (c_associated(c_radial_distance)) then
         call c_f_pointer(c_radial_distance, radial_distance,shape=[num_elements]) 
      else
         return
      end if

      if (c_associated(c_reference_elevation)) then
         call c_f_pointer(c_reference_elevation, reference_elevation,shape=[num_elements]) 
      else
         return
      end if

      allocate(elevation(num_elements))
      if (c_associated(c_elevation)) then
         call c_f_pointer(c_elevation, elevation, shape=[num_elements]) 
      else
         return
      end if

      call morphology_profile(radial_distance, reference_elevation, diameter, floordepth, &
                              floordiam, rimheight, ejrim, RIMDROP, elevation)
      return
   end subroutine bind_morphology_profile

end module morphology_module

! Copyright 2023 - David Minton
! This file is part of Cratermaker
! Cratermaker is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! Cratermaker is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with Cratermaker. 
! If not, see: https://www.gnu.org/licenses. 

!! The implementations for the Perlin noise procedures.
submodule (perlin_module) s_perlin
    use globals_module
contains
   module pure elemental subroutine perlin_noise(xx,yy,zz,noise,dx,dy,dz)
      ! Perlin noise with derivatives. Adapted from Ken Perlin's original code, with derivatives
      ! that are used in the noise functions by Giliam de Carpentier
      implicit none
      real(DP),intent(in) :: xx,yy,zz
      real(DP),intent(out) :: noise
      real(DP),intent(out),optional :: dx, dy, dz
   
      ! Internal variables
      integer(I4B) :: xi,yi,zi,A,B,AA,BB,AB,BA
      real(DP) :: x,y,z
   
      ! Intermediate variables used to calculate noise
      real(DP) :: u,v,w
      real(DP) :: GA1,GB1,GA2,GB2,GA3,GB3,GA4,GB4
      real(DP) :: L1,L2,L3,L4,LL1,LL2
   
      ! Intermediate variables used to calculate the derivative wrt x
      real(DP) :: ux,vx,wx
      real(DP) :: GA1x,GB1x,GA2x,GB2x,GA3x,GB3x,GA4x,GB4x
      real(DP) :: L1x,L2x,L3x,L4x,LL1x,LL2x
   
      ! Intermediate variables used to calculate the derivative wrt y
      real(DP) :: uy,vy,wy
      real(DP) :: GA1y,GB1y,GA2y,GB2y,GA3y,GB3y,GA4y,GB4y
      real(DP) :: L1y,L2y,L3y,L4y,LL1y,LL2y
   
      ! Intermediate variables used to calculate the derivative wrt z
      real(DP) :: uz,vz,wz
      real(DP) :: GA1z,GB1z,GA2z,GB2z,GA3z,GB3z,GA4z,GB4z
      real(DP) :: L1z,L2z,L3z,L4z,LL1z,LL2z
   
      real(DP),parameter :: hcorrection = 1.25_DP 
   
      integer(I4B),dimension(0:511),parameter :: p = (/ 151,160,137,91,90,15, &
      131,13,201,95,96,53,194,233,7,225,140,36,103,30,69,142,8,99,37,240,21,10,23,&
      190, 6,148,247,120,234,75,0,26,197,62,94,252,219,203,117,35,11,32,57,177,33,&
      88,237,149,56,87,174,20,125,136,171,168, 68,175,74,165,71,134,139,48,27,166,&
      77,146,158,231,83,111,229,122,60,211,133,230,220,105,92,41,55,46,245,40,244,&
      102,143,54, 65,25,63,161, 1,216,80,73,209,76,132,187,208, 89,18,169,200,196,&
      135,130,116,188,159,86,164,100,109,198,173,186, 3,64,52,217,226,250,124,123,&
      5,202,38,147,118,126,255,82,85,212,207,206,59,227,47,16,58,17,182,189,28,42,&
      223,183,170,213,119,248,152, 2,44,154,163, 70,221,153,101,155,167, 43,172,9,&
      129,22,39,253, 19,98,108,110,79,113,224,232,178,185, 112,104,218,246,97,228,&
      251,34,242,193,238,210,144,12,191,179,162,241, 81,51,145,235,249,14,239,107,&
      49,192,214, 31,181,199,106,157,184, 84,204,176,115,121,50,45,127, 4,150,254,&
      138,236,205,93,222,114,67,29,24,72,243,141,128,195,78,66,215,61,156,180,&
      151,160,137,91,90,15,&
      131,13,201,95,96,53,194,233,7,225,140,36,103,30,69,142,8,99,37,240,21,10,23,&
      190, 6,148,247,120,234,75,0,26,197,62,94,252,219,203,117,35,11,32,57,177,33,&
      88,237,149,56,87,174,20,125,136,171,168, 68,175,74,165,71,134,139,48,27,166,&
      77,146,158,231,83,111,229,122,60,211,133,230,220,105,92,41,55,46,245,40,244,&
      102,143,54, 65,25,63,161, 1,216,80,73,209,76,132,187,208, 89,18,169,200,196,&
      135,130,116,188,159,86,164,100,109,198,173,186, 3,64,52,217,226,250,124,123,&
      5,202,38,147,118,126,255,82,85,212,207,206,59,227,47,16,58,17,182,189,28,42,&
      223,183,170,213,119,248,152, 2,44,154,163, 70,221,153,101,155,167, 43,172,9,&
      129,22,39,253, 19,98,108,110,79,113,224,232,178,185, 112,104,218,246,97,228,&
      251,34,242,193,238,210,144,12,191,179,162,241, 81,51,145,235,249,14,239,107,&
      49,192,214, 31,181,199,106,157,184, 84,204,176,115,121,50,45,127, 4,150,254,&
      138,236,205,93,222,114,67,29,24,72,243,141,128,195,78,66,215,61,156,180 /) 
   
      x = xx
      y = yy
      z = zz
      xi = iand(floor(x),255)
      yi = iand(floor(y),255)
      zi = iand(floor(z),255)
      x = x - real(floor(x), kind=DP)
      y = y - real(floor(y), kind=DP)
      z = z - real(floor(z), kind=DP)
      u = fade(x)
      v = fade(y)
      w = fade(z)
   
      A = p(xi) + yi
      B = p(xi + 1) + yi
   
      AA = p(A) + zi
      BA = p(B) + zi
   
      AB = p(A + 1) + zi
      BB = p(B + 1) + zi
   
      GA1 = grad(p(AA    ), x        , y        , z)
      GB1 = grad(p(BA    ), x - 1._DP, y        , z)
      GA2 = grad(p(AB    ), x        , y - 1._DP, z)
      GB2 = grad(p(BB    ), x - 1._DP, y - 1._DP, z)
      GA3 = grad(p(AA + 1), x        , y        , z - 1._DP)
      GB3 = grad(p(BA + 1), x - 1._DP, y        , z - 1._DP)
      GA4 = grad(p(AB + 1), x        , y - 1._DP, z - 1._DP)
      GB4 = grad(p(BB + 1), x - 1._DP, y - 1._DP, z - 1._DP)

   
      L1 = lerp(u, GA1, GB1)
      L2 = lerp(u, GA2, GB2)
      L3 = lerp(u, GA3, GB3)
      L4 = lerp(u, GA4, GB4)

      LL1 = lerp(v, L1, L2)
      LL2 = lerp(v, L3, L4)
     
      noise = hcorrection * lerp(w, LL1, LL2)

      if (present(dx)) then
         ! Calculate derivatives wrt x
         ux = dfade(x)
         vx = 0.0_DP
         wx = 0.0_DP
         GA1x = grad(p(AA    ), 1._DP, 0._DP, 0._DP)
         GB1x = grad(p(BA    ), 1._DP, 0._DP, 0._DP)
         GA2x = grad(p(AB    ), 1._DP, 0._DP, 0._DP)
         GB2x = grad(p(BB    ), 1._DP, 0._DP, 0._DP)
         GA3x = grad(p(AA + 1), 1._DP, 0._DP, 0._DP)
         GB3x = grad(p(BA + 1), 1._DP, 0._DP, 0._DP)
         GA4x = grad(p(AB + 1), 1._DP, 0._DP, 0._DP)
         GB4x = grad(p(BB + 1), 1._DP, 0._DP, 0._DP)
   
         L1x = dlerp(u, GA1, GB1, ux, GA1x, GB1x)
         L2x = dlerp(u, GA2, GB2, ux, GA2x, GB2x)
         L3x = dlerp(u, GA3, GB3, ux, GA3x, GB3x)
         L4x = dlerp(u, GA4, GB4, ux, GA4x, GB4x)
    
         LL1x = dlerp(v, L1, L2, vx, L1x, L2x)
         LL2x = dlerp(v, L3, L4, vx, L3x, L4x)
    
         dx = hcorrection * dlerp(w, LL1, LL2, wx, LL1x, LL2x)
      end if

      if (present(dy)) then
         ! Calculate derivatives wrt y
         uy = 0.0_DP
         vy = dfade(y)
         wy = 0.0_DP
         GA1y = grad(p(AA    ), 0._DP, 1._DP, 0._DP)
         GB1y = grad(p(BA    ), 0._DP, 1._DP, 0._DP)
         GA2y = grad(p(AB    ), 0._DP, 1._DP, 0._DP)
         GB2y = grad(p(BB    ), 0._DP, 1._DP, 0._DP)
         GA3y = grad(p(AA + 1), 0._DP, 1._DP, 0._DP)
         GB3y = grad(p(BA + 1), 0._DP, 1._DP, 0._DP)
         GA4y = grad(p(AB + 1), 0._DP, 1._DP, 0._DP)
         GB4y = grad(p(BB + 1), 0._DP, 1._DP, 0._DP)
   
         L1y = dlerp(u, GA1, GB1, uy, GA1y, GB1y)
         L2y = dlerp(u, GA2, GB2, uy, GA2y, GB2y)
         L3y = dlerp(u, GA3, GB3, uy, GA3y, GB3y)
         L4y = dlerp(u, GA4, GB4, uy, GA4y, GB4y)
    
         LL1y = dlerp(v, L1, L2, vy, L1y, L2y)
         LL2y = dlerp(v, L3, L4, vy, L3y, L4y)
    
         dy = hcorrection * dlerp(w, LL1, LL2, wy, LL1y, LL2y)
      end if

      if (present(dz)) then
         ! Calculate derivatives wrt z
         uz = 0.0_DP
         vz = 0.0_DP
         wz = dfade(z)
         GA1z = grad(p(AA    ), 0._DP, 0._DP, 1._DP)
         GB1z = grad(p(BA    ), 0._DP, 0._DP, 1._DP)
         GA2z = grad(p(AB    ), 0._DP, 0._DP, 1._DP)
         GB2z = grad(p(BB    ), 0._DP, 0._DP, 1._DP)
         GA3z = grad(p(AA + 1), 0._DP, 0._DP, 1._DP)
         GB3z = grad(p(BA + 1), 0._DP, 0._DP, 1._DP)
         GA4z = grad(p(AB + 1), 0._DP, 0._DP, 1._DP)
         GB4z = grad(p(BB + 1), 0._DP, 0._DP, 1._DP)
   
         L1z = dlerp(u, GA1, GB1, uz, GA1z, GB1z)
         L2z = dlerp(u, GA2, GB2, uz, GA2z, GB2z)
         L3z = dlerp(u, GA3, GB3, uz, GA3z, GB3z)
         L4z = dlerp(u, GA4, GB4, uz, GA4z, GB4z)
    
         LL1z = dlerp(v, L1, L2, vz, L1z, L2z)
         LL2z = dlerp(v, L3, L4, vz, L3z, L4z)
    
         dz = hcorrection * dlerp(w, LL1, LL2, wz, LL1z, LL2z)
      end if
   
      return

      contains
      
         pure function fade(t) result(f)
            implicit none
            real(DP),intent(in) :: t
            real(DP) :: f
      
            f = t * t * t * (t * (t * 6._DP - 15._DP) + 10._DP)
            return
         end function fade
      
         pure function dfade(t) result(df)
            implicit none
            real(DP),intent(in) :: t
            real(DP) :: df
      
            df = t * t * (t * (t * 30._DP - 60._DP) + 30._DP)
            return
         end function dfade
      
         pure function lerp(t,a,b) result(l)
            implicit none
            real(DP),intent(in) :: t,a,b
            real(DP) :: l
      
            l = a + t * (b - a)
            return
         end function lerp
   
         pure function dlerp(t,a,b,dt,da,db) result(dl)
            implicit none
            real(DP),intent(in) :: t,a,b
            real(DP),intent(in) :: dt,da,db
            real(DP) :: dl
      
            dl = da + t * (db - da) + dt * (b - a)

            return
         end function dlerp
   
         pure function grad(hash,x,y,z) result(g)
            implicit none
            integer(I4B),intent(in) :: hash
            real(DP),intent(in) :: x,y,z
            real(DP) :: g,u,v
            integer(I4B) :: h
      
            h = iand(hash,15) 
            if (h < 8) then 
               u = x
            else
               u = y
            end if
            if (h < 4) then
               v = y
            else if ((h == 12) .or. (h == 14)) then
               v = x
            else
               v = z
            end if
            if (iand(h,1 ) == 0) then
               g = u
            else 
               g = -u
            end if
            if (iand(h, 2) == 0) then
               g = g + v
            else
               g = g - v
            end if
            return
         end function grad
   
   end subroutine perlin_noise


   module pure function perlin_turbulence(x, y, z, noise_height, freq, pers, num_octaves, anchor) result(noise)
      implicit none
      real(DP), intent(in) ::  x, y, z, noise_height, freq, pers
      integer(I4B), intent(in) :: num_octaves
      real(DP), dimension(:,:),intent(in) :: anchor
      real(DP) :: noise,xnew,ynew,znew,norm
      
      integer(I4B) :: i
      real(DP) :: spatial_fac, noise_mag,dn
      
      noise = 0.0_DP
      norm = 0.5_DP
      do i = 1, num_octaves
         spatial_fac = freq ** (i - 1)
         noise_mag = pers ** (i - 1)
         norm = norm + 0.5_DP * noise_mag
         xnew = (x + anchor(1,i)) * spatial_fac
         ynew = (y + anchor(2,i)) * spatial_fac
         znew = (z + anchor(3,i)) * spatial_fac
         call perlin_noise(xnew,ynew,znew,dn)
         noise = noise + dn * noise_mag
      end do
      
      noise = noise * noise_height / norm
      
      return
      
   end function perlin_turbulence


   module pure function perlin_billowedNoise(x, y, z, noise_height, freq, pers, num_octaves, anchor) result(noise)
      implicit none
      real(DP), intent(in) ::  x, y, z, noise_height, freq, pers
      integer(I4B), intent(in) :: num_octaves
      real(DP),dimension(:,:),intent(in) :: anchor
      real(DP) :: noise
      
      noise = abs(perlin_turbulence(x, y, z, noise_height, freq, pers, num_octaves, anchor))
      
      return
   end function perlin_billowedNoise
      
      
   module pure function perlin_plawNoise(x, y, z, noise_height, freq, pers, slope, num_octaves, anchor) result(noise)
      implicit none
      real(DP), intent(in) ::  x, y, z, noise_height, freq, pers,slope
      integer(I4B), intent(in) :: num_octaves
      real(DP),dimension(:,:),intent(in) :: anchor
      real(DP) :: noise
      
      noise = perlin_turbulence(x, y, z, noise_height, freq, pers, num_octaves, anchor)
      noise = sign(abs(noise)**(slope),noise)
      
      return
   end function perlin_plawNoise
      
      
   module pure function perlin_ridgedNoise(x, y, z, noise_height, freq, pers, num_octaves, anchor) result(noise)
      implicit none
      real(DP), intent(in) ::  x, y, z, noise_height, freq, pers
      integer(I4B), intent(in) :: num_octaves
      real(DP),dimension(:,:),intent(in) :: anchor
      real(DP) :: noise
      
      noise = noise_height - abs(perlin_turbulence(x, y, z, noise_height, freq, pers, num_octaves, anchor))
      
      return
   end function perlin_ridgedNoise
      
      
   module pure function perlin_swissTurbulence(x, y, z, lacunarity, gain, warp, num_octaves, anchor) result(noise)
      implicit none
      ! Arguments
      real(DP), intent(in) ::  x, y, z, lacunarity, gain, warp
      integer(I4B), intent(in) :: num_octaves
      real(DP),dimension(:,:), intent(in) :: anchor
      ! Result
      real(DP) :: noise
      ! Internals
      real(DP) :: freq, amp,xnew,ynew,znew, norm
      real(DP),dimension(3) :: dsum
      real(DP),dimension(4) :: n
      integer(I4B) :: i
   
      noise =  0.0_DP
      freq = 1.0_DP
      amp = 1.0_DP
      dsum(:) = 0._DP
   
      norm = 0.5_DP
         
      do i = 1, num_octaves 
         xnew = (x + anchor(1,i) + warp * dsum(1)) * freq
         ynew = (y + anchor(2,i) + warp * dsum(2)) * freq
         znew = (z + anchor(3,i) + warp * dsum(3)) * freq
         call perlin_noise(xnew,ynew,znew,n(1),dx = n(2),dy = n(3), dz = n(4))
         noise = noise + amp * (1._DP - abs(n(1)))
         norm = norm + amp
         dsum(:) = dsum(:) + amp * n(2:4) * (-n(1))
         freq = freq * lacunarity;
         amp = amp * gain * max(min(noise,1.0_DP),0.0_DP)
      end do
      noise = noise  
      return
   
   end function perlin_swissTurbulence
   
      
   module pure function perlin_jordanTurbulence(x, y, z, lacunarity, gain0, gain, warp0, warp, damp0, damp, damp_scale,&
            num_octaves, anchor) result(noise)
      ! Fortran implementation of noise function by Giliam de Carpentier
      implicit none
      real(DP),intent(in) :: x, y, z, lacunarity, gain0, gain, warp0, warp, damp0, damp, damp_scale
      integer(I4B),intent(in) :: num_octaves
      real(DP), dimension(:,:), intent(in) :: anchor
      ! Result variable
      real(DP) :: noise
   
      ! Internal variables
      real(DP),dimension(4) :: n,n2
      real(DP),dimension(3) :: dsum_warp,dsum_damp
      real(DP) :: freq,damped_amp,xnew,ynew,znew, amp
      integer(I4B) :: i
   
      xnew = x + anchor(1,1)
      ynew = y + anchor(2,1)
      znew = z + anchor(3,1)
      call perlin_noise(xnew,ynew,znew, n(1),dx = n(2),dy = n(3), dz = n(4))
      n2(:) = n(:) * n(1)
      noise = n2(1)
      dsum_warp(:) = warp0 * n2(2:4)
      dsum_damp(:) = damp0 * n2(2:4)
   
      freq = lacunarity
      amp = gain0
      damped_amp = amp * gain
   
      do i = 2, num_octaves
         xnew = x * freq + dsum_warp(1) + anchor(1,i)
         ynew = y * freq + dsum_warp(2) + anchor(2,i)
         znew = z * freq + dsum_warp(3) + anchor(3,i)
         call perlin_noise(xnew,ynew,znew,n(1),dx = n(2),dy = n(3),dz = n(4))
         n2(:) = n(:) * n(1)
         noise = noise + damped_amp * n2(1)
         dsum_warp(:) = dsum_warp(:) + warp * n2(2:4)
         dsum_damp(:) = dsum_damp(:) + damp * n2(2:4)
         freq = freq * lacunarity
         amp = amp * gain
         damped_amp = amp * (1._DP - damp_scale / (1._DP + dot_product(dsum_damp(:),dsum_damp(:))))
      end do
      return 
   end function perlin_jordanTurbulence


   module pure function perlin_noise_one(model, x, y, z, num_octaves, anchor, damp, damp0, damp_scale, freq, gain, gain0,&
                                          lacunarity, noise_height, pers, slope, warp, warp0) result(noise)
      implicit none
      character(len=*), intent(in) :: model !! The specific turbulence model to apply
      real(DP), intent(in) :: x, y, z  !! The xyz cartesian position of the noise to evaluate
      integer(I4B), intent(in) :: num_octaves
      real(DP), dimension(:,:), intent(in) :: anchor
      real(DP), intent(in) :: damp, damp0, damp_scale, freq, gain, gain0, lacunarity, noise_height, pers, slope, warp, warp0
      real(DP) :: noise

      select case (trim(model))
      case('turbulence')
         noise = perlin_turbulence(x, y, z, noise_height, freq, pers, num_octaves, anchor) 
      case('billowed')
         noise = perlin_billowedNoise(x, y, z, noise_height, freq, pers, num_octaves, anchor)
      case('plaw')
         noise = perlin_plawNoise(x, y, z, noise_height, freq, pers, slope, num_octaves, anchor)
      case('ridged')
         noise = perlin_ridgedNoise(x, y, z, noise_height, freq, pers, num_octaves, anchor)
      case('swiss')
         noise = perlin_swissTurbulence(x, y, z, lacunarity, gain, warp, num_octaves, anchor)
      case('jordan')
         noise = perlin_jordanTurbulence(x, y, z, lacunarity, gain0, gain, warp0, warp, damp0, damp,& 
                                                damp_scale, num_octaves, anchor) 
      case default
         noise = 0.0_DP
      end select
      return
   end function perlin_noise_one


   module subroutine perlin_noise_all(model, x, y, z, num_octaves, anchor, damp, damp0, damp_scale, freq, gain, gain0,&
                                          lacunarity, noise_height, pers, slope, warp, warp0, noise)
      implicit none
      character(len=*), intent(in) :: model !! The specific turbulence model to apply
      real(DP), dimension(:), intent(in) :: x, y, z  !! The xyz cartesian position of the noise to evaluate
      integer(I4B), intent(in) :: num_octaves
      real(DP), dimension(:,:), intent(in) :: anchor
      real(DP), intent(in) :: damp, damp0, damp_scale, freq, gain, gain0, lacunarity, noise_height, pers, slope, warp, warp0
      real(DP), dimension(:), intent(out) :: noise
      integer :: i, N

      N = size(x)

      select case (trim(model))
      case('turbulence')
         do concurrent(i = 1:N)
            noise(i) = perlin_turbulence(x(i), y(i), z(i), noise_height, freq, pers, num_octaves, anchor) 
         end do
      case('billowed')
         do concurrent(i = 1:N)
            noise(i) = perlin_billowedNoise(x(i), y(i), z(i), noise_height, freq, pers, num_octaves, anchor)
         end do
      case('plaw')
         do concurrent(i = 1:N)
            noise(i) = perlin_plawNoise(x(i), y(i), z(i), noise_height, freq, pers, slope, num_octaves, anchor)
         end do
      case('ridged')
         do concurrent(i = 1:N)
            noise(i) = perlin_ridgedNoise(x(i), y(i), z(i), noise_height, freq, pers, num_octaves, anchor)
         end do
      case('swiss')
         do concurrent(i = 1:N)
            noise(i) = perlin_swissTurbulence(x(i), y(i), z(i), lacunarity, gain, warp, num_octaves, anchor)
         end do
      case('jordan')
         do concurrent(i = 1:N)
            noise(i) = perlin_jordanTurbulence(x(i), y(i), z(i), lacunarity, gain0, gain, warp0, warp, damp0, damp,& 
                                                damp_scale, num_octaves, anchor) 
         end do
      case default
         noise(:) = 0.0_DP
      end select
      return
   end subroutine perlin_noise_all

end submodule s_perlin

! Copyright 2023 - David Minton
! This file is part of Cratermaker
! Cratermaker is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
! as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
! cratermaker is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
! of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
! You should have received a copy of the GNU General Public License along with cratermaker. 
! If not, see: https://www.gnu.org/licenses. 

!! Type definitions and global parameters for Cratermaker project. All types are defined using ISO_C_BINDING types to ensure that
!! the types are compatible with the Cython interface.
module globals_module
    !! author: David A. Minton
    !!
    !! Basic parameters, definitions, and global type definitions used throughout the Cratermaker project
    use, intrinsic :: iso_c_binding  ! Use the intrinsic kind definitions
    implicit none
    public

    integer, parameter :: I8B = c_int_least64_t !! Symbolic name for kind types of 8-byte integers
    integer, parameter :: I4B = c_int_least32_t !! Symbolic name for kind types of 4-byte integers
    integer, parameter :: I2B = c_int_least16_t !! Symbolic name for kind types of 2-byte integers
    integer, parameter :: I1B = c_int_least8_t  !! Symbolic name for kind types of 1-byte integers

    integer, parameter :: SP = c_float  !! Symbolic name for kind types of single-precision reals
    integer, parameter :: DP = c_double  !! Symbolic name for kind types of double-precision reals
    integer, parameter :: QP = c_long_double !! Symbolic name for kind types of quad-precision reals

    integer(I4B), parameter :: STRMAX = 512 !! Maximum size of character strings 

    ! Frequently used mathematical constants 
    real(DP), parameter :: PI       = ACOS(-1.0_DP) 
    real(DP), parameter :: SQRT2    = SQRT(2.0_DP) 
    real(DP), parameter :: LOGSQRT2 = LOG(SQRT2) 
    real(DP), parameter :: SQRT3    = SQRT(3.0_DP) 
    real(DP), parameter :: THIRD    = 1.0_DP / 3.0_DP 
    real(DP), parameter :: SIXTH    = 1.0_DP / 6.0_DP 
    real(DP), parameter :: DEG2RAD  = PI / 180.0_DP 
    
end module globals_module

#!/bin/bash
#
# This gets the current gfortran version number
# 
# Copyright 2024 - The Minton Group at Purdue University
# This file is part of Cratermaker.
# Cratermaker is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Cratermaker is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Cratermaker. 
# If not, see: https://www.gnu.org/licenses. 

FC="$(command -v gfortran-14 || command -v gfortran-13 || command -v gfortran-12 || command -v gfortran)"
echo "$(${FC} --version | head -n1 | awk '{print $NF}' | cut -d. -f1)"
set +a

#!/bin/bash
#
# This gets the current system's MacOS version number and converts it from its full version to just major version. For instance, if
# the MacOS version is 14.4.1 then this script will return 14.0. 
# 
# Copyright 2024 - The Minton Group at Purdue University
# This file is part of Cratermaker.
# Cratermaker is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Cratermaker is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Cratermaker. 
# If not, see: https://www.gnu.org/licenses. 

OS=$(uname -s)
if [ $OS = "Darwin" ]; then
    echo "$(sw_vers -productVersion | cut -d. -f1).0" 
else
    echo ""
fi
set +a

#!/bin/bash
# Sets environment variables for Linux or Mac. This script is designed so that the build system can be customized by the user simply
# by defining any environment variables prior to running this script.
# 
#
# The following variables are set by this script:
# 
# PREFIX: The installation directory for the dependencies
# NCDIR: The installation directory for the netcdf-c library
# NETCDF_FORTRAN_HOME: The installation directory for the netcdf-fortran library
# NFDIR: Alternate name for the installation directory for the netcdf-fortran library
# NETCDF_FORTRAN_INCLUDE: The include directory for the netcdf-fortran library
# ZLIB_ROOT: The installation directory for the zlib library
# SZIP_ROOT: The installation directory for the szip library
# BZ2_ROOT: The installation directory for the bzip2 library
# ZSTD_ROOT: The installation directory for the zstd library
# HDF5_ROOT: The installation directory for the hdf5 library
# HDF5_LIBDIR: The library directory for the hdf5 library
# HDF5_INCLUDE_DIR: The include directory for the hdf5 library
# HDF5_PLUGIN_PATH: The plugin directory for the hdf5 library
# HDF5_DIR: The cmake directory for the hdf5 library
# SHTOOLS_HOME: The installation directory for the SHTOOLS library
# LD_LIBRARY_PATH: The library path for the dependencies
# CPATH: The include path for the dependencies
# PATH: The path for the dependency binaries
# CMAKE_INSTALL_LIBDIR: The cmake install directory name (default is "lib"). This is used to override the behavior in Linux systems that use lib64 instead of lib in order that dependency libraries are installed in a consistent location.
# MACOSX_DEPLOYMENT_TARGET: The macOS deployment target (for macOS only)
# HOMEBREW_PREFIX: The homebrew prefix (for macOS only)
# DYLD_LIBRARY_PATH: The dynamic library path (for macOS only)
# LDFLAGS: The linker flags (defined for macOS only)
# CFLAGS: The C compiler flags (defined for macOS only)
# FCFLAGS: The Fortran compiler flags (defined for macOS only)
# FFLAGS: The Fortran 77 compiler flags (defined for macOS only)
# CXXFLAGS: The C++ compiler flags (defined for macOS only)
# CPPFLAGS: The C preprocessor flags (defined for macOS only)
# FC: The Fortran compiler
# F77: The Fortran 77 compiler
# F95: The Fortran 95 compiler
# CC: The C compiler (defined for macOS only)
# CXX: The C++ compiler (defined for macOS only)
# 
# Copyright 2024 - The Minton Group at Purdue University
# This file is part of Cratermaker.
# Cratermaker is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Cratermaker is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Cratermaker. 
# If not, see: https://www.gnu.org/licenses. 

SCRIPT_DIR=$(realpath $(dirname $0))
ROOT_DIR=$(realpath ${SCRIPT_DIR}/..)
OS=$(uname -s)

set -a
PREFIX="${PREFIX:-/usr/local}"
DEPENDENCY_DIR="${PREFIX}"
LD_LIBRARY_PATH="${PREFIX}/lib"
CPATH="${PREFIX}/include"
PATH="${PREFIX}/bin:${PATH}"
CMAKE_INSTALL_LIBDIR="lib"
NPROC=$(nproc)

FC="$(${SCRIPT_DIR}/get_gfortran_path.sh)"
F77="${FC}"
F95="${FC}"
GFORTRAN_VERSION="$(${SCRIPT_DIR}/get_gfortran_version.sh)"

if [ $OS = "Darwin" ]; then
    CC="/usr/bin/clang"
    CXX="/usr/bin/clang++"
    MACOSX_DEPLOYMENT_TARGET=${MACOSX_DEPLOYMENT_TARGET:-"$(${SCRIPT_DIR}/get_macosx_deployment_target.sh)"}
    ARCH="$(uname -m)"
    HOMEBREW_PREFIX=${HOMEBREW_PREFIX:-"$(brew --prefix)"}
    SDKROOT=$(xcrun --sdk macosx --show-sdk-path)
    CMAKE_OSX_SYSROOT="${SDKROOT}"
    LD_LIBRARY_PATH="${LD_LIBRARY_PATH}:${HOMEBREW_PREFIX}/lib:${HOMEBREW_PREFIX}/lib/gcc/${GFORTRAN_VERSION}"
    DYLD_LIBRARY_PATH="${LD_LIBRARY_PATH}"
    LDFLAGS="-Wl,-no_compact_unwind -L${PREFIX}/lib -L${HOMEBREW_PREFIX}/lib"
    CPATH="${CPATH}:${HOMEBREW_PREFIX}/include"
    CPPFLAGS="-isystem ${PREFIX}/include -Xclang -fopenmp"
    LIBS="-lomp -lquadmath"
    CFLAGS="-mmacosx-version-min=${MACOSX_DEPLOYMENT_TARGET} -Wno-deprecated-non-prototype -arch ${ARCH}"
    FCFLAGS="-mmacosx-version-min=${MACOSX_DEPLOYMENT_TARGET}"
    FFLAGS="${FCFLAGS}"
    CXXFLAGS="${CFLAGS}"
    PATH="${HOMEBREW_PREFIX}/opt/coreutils/libexec/gnubin:${HOMEBREW_PREFIX}/bin:${PATH}"
else
    CC="$(command -v cc)"
    CXX="$(command -v c++)"
    LIBS="-lgomp"
    CFLAGS="-Wa,--noexecstack -fPIC"
    FCFLAGS="${CFLAGS}"
    FFLAGS="${FCFLAGS}"
    CXXFLAGS="${CFLAGS}"
    PATH="${MPI_HOME}/bin:${PATH}"
fi
set +a

#!/bin/bash
# This script will download the correct OpenMP library for a given MacOS deployment target
# 
# Copyright 2024 - The Minton Group at Purdue University
# This file is part of Cratermaker.
# Cratermaker is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Cratermaker is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Cratermaker. 
# If not, see: https://www.gnu.org/licenses. 

# Determine the platform and architecture
OS=$(uname -s)
# If it is not Darwin then exit
if [ $OS != "Darwin" ]; then
   echo "This script is only for MacOS"
   exit 1
fi

SCRIPT_DIR=$(realpath $(dirname $0))
ROOT_DIR=$(realpath ${SCRIPT_DIR}/..)

set -e
cd $ROOT_DIR
. ${SCRIPT_DIR}/set_environment.sh

TARGET_MAJOR=`echo $MACOSX_DEPLOYMENT_TARGET | cut -d. -f1`
TARGET_MINOR=`echo $MACOSX_DEPLOYMENT_TARGET | cut -d. -f2`
TARGET_REV=`echo $MACOSX_DEPLOYMENT_TARGET | cut -d. -f3`

#Figure out which version to get
case $TARGET_MAJOR in
   14|15)
      OMPVER="16.0.4"
      DVER="20"
      ;;
   13)
      OMPVER="14.0.6"
      DVER="20"
      ;;
   12)
      if ((TARGET_MINOR>=5)); then
         OMPVER="14.0.6"
         DVER="20"
      else
         OMPVER="13.0.0"
         DVER="21"
      fi
      ;;
   11)
      if ((TARGET_MINOR>=3)); then
         OMPVER="12.0.1"
         DVER="20"
      else
         OMPVER="11.0.1"
         DVER="20"
      fi
      ;;
   10)
      DVER="17"
      case $TARGET_MINOR in
         15)
            case $TARGET_REV in
               4)
                  OMPVER="10.0.0"
                  ;;
               2)
                  OMPVER="9.0.1"
                  ;;
            esac
            ;;
         14)
            case $TARGET_REV in
               4)
                  OMPVER="8.0.1"
                  ;;
               3)
                  OMPVER="7.1.0"
                  ;;
            esac
            ;;
         *)
            OMPVER="7.1.0"
            ;;
      esac
      ;;
esac

printf "*********************************************************\n"
printf "*             FETCHING OPENMP LIBRARY                   *\n"
printf "*********************************************************\n"
LOMP_DIR="${PREFIX}/../.."
printf "Copying files to ${LOMP_DIR}\n"
mkdir -p ${DEPENDENCY_DIR}

filename="openmp-${OMPVER}-darwin${DVER}-Release.tar.gz"
#Download and install the libraries
printf "Downloading ${filename}\n"
if [ -w "${LOMP_DIR}" ]; then
   curl -L https://mac.r-project.org/openmp/${filename} | tar xvz -C ${LOMP_DIR}
else
   sudo curl -L https://mac.r-project.org/openmp/${filename} | tar xvz -C ${LOMP_DIR}
fi

---
project: Cratermaker
author: David A. Minton
summary: High performance Fortran functions used by the Cratermaker project via ISO_C_BINDING interfaces and Cython.
project_github: https://github.com/profminton/cratermaker
project_download: https://github.com/profminton/cratermaker/releases
project_website: https://cratermaker.readthedocs.io
github: https://github.com/profminton/
src_dir: src
output_dir: ./docs/_static/fortran_docs
source: true
graph: true
sort: alpha
print_creation_date: true
extra_mods: iso_c_binding:https://gcc.gnu.org/onlinedocs/gfortran/ISO_005fC_005fBINDING.html
creation_date: %Y-%m-%d %H:%M %z
md_extensions: markdown.extensions.toc
               markdown.extensions.smarty
---

This is the documentation for the Fortran components of Cratermaker
